1 REMark &&SSBGEN
10 :
12 REMark '' VER 231124_1913
14 :
16 QLC_INIT
18 :
20 KCtrlA = 1
22 KDown = 216
24 KUp = 208
26 KShiftDown = 220
28 KTab = 9
30 KShiftF5 = 250
32 KSpace = 32
34 KShiftUp = 212
36 KEnter = 10
38 KShiftEnter = 254
40 KBackSpace = 194
42 KCtrlUp = 210
44 KCtrlDown = 218
46 KCtrlD = 4
48 KCtrlR = 18
50 KF1 = 232
52 KF2 = 236
54 KF3 = 240
56 KF4 = 244
58 KF5 = 248
60 KF6ShiftF1 = 234
62 KF7ShiftF2 = 238
64 KF8ShiftF3 = 242
66 KF9ShiftF4 = 246
68 KF10ShiftF5 = 250
70 KPlus = 43
72 KMinus = 45
74 KEqual = 61
76 KUnderscore = 95
78 KCtrlI = 92
80 KCtrlW = 23
82 KCtrlX = 24
84 KCtrl1 = 145
86 KCtrl2 = 146
88 KHome = 193
90 KEnd = 201
92 KPageUp = 212
94 KPageDown = 220
96 :
98 :
100 :
102 :
104 REMark ''******************************************
106 REMark ''*        QLX   C O M M A N D E R         *
108 REMark ''*                                        *
110 REMark ''*              version 2.1               *
112 REMark ''*          code date 2023.11.13          *
114 REMark ''*                                        *
116 REMark ''*              Andrei Tenu               *
118 REMark ''*              Martyn Hill               *
120 REMark ''*                7alken                  *
122 REMark ''******************************************
124 :
126 :
128 REMark ''*** QLiberator Directives...
130 REMark ''$$stak=5120
132 :
134 :
136 REMark ''*** TURBO Directives...
138 REMark '' - also comment line 1370! And modify line 3010
140 REMark ''TURBO_locstr "R"
142 REMark ''TURBO_ref
144 REMark ''TURBO_windo 2
146 REMark ''TURBO_optim "B"
148 REMark ''TURBO_model 1
150 REMark ''TURBO_struct "S"
152 REMark ''TURBO_diags "I"
154 REMark ''TURBO_list "YES"
156 REMark ''TURBO_sound "YES"
158 REMark ''TURBO_objdat 64
160 REMark ''TURBO_buffersz 16
162 REMark ''TURBO_objstk 512
164 REMark ''TURBO_taskn "QLC v2.0"
166 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
168 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
170 :
172 :
174 WHEN ERRor
176     REMark ''CloseProgram
178     PAPER# 1, 7
180     INK# 1, 2
182     PAPER# 0, 0
184     INK# 0, 4
186     CLS# 0
188     PRINT# 1, "Error at line: "; ERLIN%
190     REPORT
192     STOP
194 END WHEN
196 :
198 REMark ''mode 4: paper#0,0:paper#1,0:paper#2,0:border#1,0:cls#1
200 REMark ''window#1,488,220,12,0
202 :
204 REMark ''----------------------------------------------------------
206 REMark ''recompilation QLXC from ssb source
208 DEFine PROCedure c
210     LOCal ssb_fn$, test_fn$
212 :
214     ssb_fn$ = "dos1_QLC_qlxc_ssb"
216     bas_fn$ = ssb_fn$(1 TO LEN(ssb_fn$) - 4) & "_bas"
218 :
220     PRINT #0, "Compiling SSB to BAS ..."
222     _err = CompileSsb2Bas(ssb_fn$, bas_fn$)
224 :
226     TYPE_IN "l" & CHR$(10) : REMark ''reload bas
228     AttachBasFileShell bas_fn$
230     REMark ''print #0, "Attaching QLXC Shell ..."
232     TYPE_IN "r" & CHR$(10) : REMark ''run
234     REMark ''print #0, "Test ..."
236 END DEFine
238 :
240 xc
242 :
244 REMark ''----------------------------------------------------------
246 DEFine PROCedure xc
248 :
250     qlcVer$ = "2.1"
252     REMark ''Make sure that guardian window covers all screen,
254     REMark ''in all resolutions
256     IF VER$="HBA_xx"  : REMark ''FIXME mixworx
258         maxWinWid% = SCR_XLIM
260         maxWinHgt% = SCR_YLIM
262     ELSE
264         maxWinWid% = 512
266         maxWinHgt% = 256
268         REMark ''make sure we are in monitor mode 4,
270         REMark ''otherwise it will crash
272         WMON
274         MODE 4
276         PAPER# 0, 0
278         PAPER# 1, 0
280         BORDER# 1, 0
282         CLS# 1
284         CLS# 0
286     END IF
288     REMark ''comment next line if compiled with Turbo !
290     PAPER# 0, 0
292     BORDER# 0, 0
294     PAPER# 1, 0
296     BORDER# 1, 0
298     PAPER# 2, 0
300     BORDER# 2, 0
302     CLS# 0
304     CLS# 1
306     CLS# 2
308     WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
310     OUTLN# 0, maxWinWid%, maxWinHgt%, 0, 0, 0, 0, 0
312 :
314 :
316     dbginit
318     readConfig
320     InitialiseVars
322     OpenWindows
324     DrawWindows 1
326     MainLoop
328     CloseProgram
330 :
332     STOP
334 END DEFine
336 :
338 REMark ''----------------------------------------------------------
340 DEFine PROCedure StopWithError(errorMessage$)
342 :
344     BEEP 1390 * 2, 20
346     REMark ''cls #0
348     PRINT #0, errorMessage$
350     PAUSE 50 * 2
352     CloseProgram
354     STOP
356 END DEFine
358 :
360 :
362 REMark ''-----------------------------------------------------------
364 DEFine PROCedure CloseProgram
366     LOCal ch%
368 :
370     FOR ch% = 3 TO 9 : CLOSE# ch% : END FOR ch%
372 :
374     IF headBuff > 0 THEN RECHP(headBuff)
376     IF titleFountBase > 0 THEN RECHP titleFountBase
378     IF mainFountBase > 0 THEN RECHP mainFountBase
380     IF comFountBase > 0 THEN RECHP comFountBase
382 :
384     DATA_USE initialDATAD$
386 :
388     WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
390     PAPER# 0, 0
392     INK# 0, White%
394     CLS# 0
396 :
398     WINDOW# 0, 512, 50, 0, 206
400     BORDER# 0, 1, 1, 7, 0
402     CLS# 0
404 :
406     WINDOW# 1, 256, 202, 256, 0
408     BORDER# 1, 1, 1, 7, 0
410     PAPER# 1, 7
412     INK# 1, 0
414     CLS# 1
416 :
418     WINDOW# 2, 256, 202, 0, 0
420     BORDER# 2, 1, 1, 7, 0
422     PAPER# 2, 2
424     INK# 2, 7
426     CLS# 2
428 :
430 END DEFine
432 :
434 :
436 REMark ''-----------------------------------------------------------
438 DEFine PROCedure OpenWindows
440     LOCal ch%, titleFountFN$(36), titleFountLen%
442     LOCal mainFountFN$(36), mainFountLen%
444     LOCal comFountFN$(36), comFountLen%
446 :
448     stdFountWid% = 6
450 :
452     FOR ch% = 3 TO 9 : OPEN# ch%, con : END FOR ch%
454 :
456     titleFountWid% = stdFountWid%
458     titleFountBase = 0
460     titleFountFN$ = ConfigDrv$ & "bold8_fnt"
462 :
464     IF FTEST(titleFountFN$) = 0
466         REMark ''use _+ as #, __+ as \ ???
468         titleFountLen% = FLEN(\titleFountFN$)
470         IF titleFountLen% > 0
472             titleFountBase = ALCHP(titleFountLen%)
474             LBYTES titleFountFN$, titleFountBase
476             titleFountWid% = 8
478             CHAR_USE# titleWin%, titleFountBase, 0
480             CSIZE# titleWin%,1,0
482             CHAR_INC# titleWin%, titleFountWid%, 10
484         END IF
486     END IF
488 :
490     mainFountWid% = stdFountWid%
492     mainFountBase = 0
494     mainFountFN$ = ConfigDrv$ & "5Pixel_fnt"
496     IF FTEST(mainFountFN$) = 0
498         REMark ''use _+ as #, __+ as \ ???
500         mainFountLen% = FLEN(\mainFountFN$)
502         IF mainFountLen% > 0
504             mainFountBase = ALCHP(mainFountLen%)
506             LBYTES mainFountFN$, mainFountBase
508         END IF
510     END IF
512 :
514     SELect ON ClassicFont%
516       = 0:
518           IF mainFountBase > 0
520               mainFountWid% = 5
522               mainFountHeight% = 10
524               CHAR_USE# leftPanelWin%, mainFountBase, 0
526               CHAR_INC# leftPanelWin%, mainFountWid%, 10
528               CHAR_USE# rightPanelWin%, mainFountBase, 0
530               CHAR_INC# rightPanelWin%, mainFountWid%, 10
532           ELSE
534               mainFountWid% = 6
536               mainFountHeight% = 10
538               comFountWid% = stdFountWid%
540           END IF
542 :
544       = 1:
546           CSIZE# leftPanelWin%, 0, 0
548           CSIZE# rightPanelWin%, 0, 0
550           mainFountWid% = 6
552           mainFountHeight% = 10
554           comFountWid% = stdFountWid%
556 :
558       = 2:
560           mainFountWid% = 8
562           mainFountHeight% = 20
564           comFountWid% = 8
566           titleFountWid% = 16
568           CSIZE# leftPanelWin%, 1, 1
570           CSIZE# rightPanelWin%, 1, 1
572           CSIZE# titleWin%, 3, 1
574           CSIZE# 4, 1, 1
576           CSIZE# 5, 1, 1
578           CSIZE# 6, 1, 1
580           CSIZE# 9, 1, 1
582 :
584       = 3:
586           mainFountWid% = 12
588           mainFountHeight% = 20
590           titleFountWid% = 16
592           comFountWid% = 8
594           CSIZE# leftPanelWin%, 2, 1
596           CSIZE# rightPanelWin%, 2, 1
598           CSIZE# titleWin%, 3, 1
600           CSIZE# 4, 2, 1
602           CSIZE# 5, 2, 1
604           CSIZE# 6, 2, 1
606           CSIZE# 9, 1, 1
608     END SELect
610 :
612     REMark ''comFountWid%=stdFountWid%
614     comFountBase = 0
616     comFountFN$ = ConfigDrv$ & "qlc_fnt"
618 :
620     IF FTEST(comFountFN$) = 0
622         REMark ''use _+ as #, __+ as \ ???
624         comFountLen% = FLEN(\comFountFN$)
626         IF comFountLen% > 0
628             comFountBase = ALCHP(comFountLen%)
630             LBYTES comFountFN$, comFountBase
632             CHAR_USE# comWin%, comFountBase, 0
634         END IF
636     END IF
638 :
640 END DEFine
642 :
644 :
646 REMark ''-----------------------------------------------------------
648 REMark ''reload% = 1 we reload the file lists and draw the windows;
650 REMark ''reload%==0 we do not reload the file lists,
652 REMark ''just redraw the windows
654 DEFine PROCedure DrawWindows(reload%)
656     LOCal left%
658     LOCal ch%, w%, h%, x%, y%, c%, px%, py%
660 :
662     IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2)
664         linelen% = ((maxWinWid% DIV 2) - 4) DIV mainFountWid%
666     END IF
668     panelWinWid% = linelen% * mainFountWid% + 2
670     comWinWid% = 2 * panelWinWid%
672     left% = (maxWinWid% - 2 * panelWinWid%) DIV 2
674 :
676     REMark ''title line
678     ch% = 3
680     x% = 2 * panelWinWid%
682     y% = mainFountHeight% + 2
684     px% = left%
686     py% = 5
688     WINDOW# ch%, x%, y%, px%, py%
690     BORDER# ch%, 1, TitleBorder%
692     PAPER# ch%, TitleBorder%, TitleBk%, 1
694     CLS# ch%
696 :
698     PAPER# ch%, 0
700     INK# ch%, 2
702     IF ClassicFont% >= 2
704         CSIZE# titleWin%, 3, 1
706     ELSE
708         CSIZE# titleWin%, 1, 0
710     END IF
712     CHAR_INC# titleWin%, titleFountWid%, 10
714 :
716 :
718     REMark ''FIXME long lines, use vars here !!!!!!
720     REMark ''LONGLINE
722     ch% = 3
724     w% = titleFountWid% * 14
726     h% = mainFountHeight%
728     x% = (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2
730     y% = 0
732     c% = 0
734     BLOCK# ch%, w%, h%, x%, y%, c%
736     x% = (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2
738     y% = 0
740     CURSOR# ch%, x%, y%
742     PRINT# ch%, " QLX COMMANDER "
744 :
746     REMark ''Drive line
748     REMark ''LONGLINE
750     ch% = 4
752     x% = 2 * panelWinWid%
754     y% = mainFountHeight% + 2
756     px% = left%
758     py% = mainFountHeight% + 7
760     WINDOW# ch%, x%, y%, px%, py%
762     PAPER# ch%, brd%
764     INK# ch%, 0
766     BORDER# ch%, 1, brd%
768     CLS# ch%
770 :
772     AT# ch%, 0, 0
774     INK# ch%, 2
776     PRINT# ch%, "D"
778     AT# ch%, 0, 1
780     INK# ch%, 0
782     PRINT# ch%, "ir"
784     CURSOR# ch%, panelWinWid%, 0
786     PRINT# ch%, "Di"
788     INK# ch%, 2
790     CURSOR# ch%, panelWinWid% + mainFountWid% * 2, 0
792     PRINT# ch%, "r"
794 :
796     REMark ''left dir
798     REMark ''LONGLINE
800     ch% = 5
802     x% = panelWinWid% - 4 * mainFountWid%
804     y% = mainFountHeight%
806     px% = left% + 4 * mainFountWid% - 2
808     py% = mainFountHeight% + 8
810     WINDOW# ch%, x%, y%, px%, py%
812     PAPER# ch%, White%
814     INK# ch%, 0
816     BORDER# ch%, 0
818     CLS# ch%
820     PRINT# ch%, leftDir$
822 :
824     REMark ''right dir
826     REMark ''LONGLINE
828     ch% = 6
830     x% = panelWinWid% - 4 * mainFountWid%
832     y% = mainFountHeight%
834     px% = left% + panelWinWid% + 4 * mainFountWid% - 2
836     py% = mainFountHeight% + 8
838     WINDOW# ch%, x%, y%, px%, py%
840     PAPER# ch%, White%
842     INK# ch%, 0
844     BORDER# ch%, 0
846     CLS# ch%
848     PRINT# ch%, rightDir$
850 :
852     panelWinHeight% = rowno% * mainFountHeight% + 3
854     IF panelWinHeight% + 3 * mainFountHeight% + 19 > maxWinHgt%
856         REMark ''LONGLINE
858         rowno% = (maxWinHgt% - 3 * mainFountHeight% - 22) DIV mainFountHeight%
860         panelWinHeight% = rowno% * mainFountHeight% + 3
862     END IF
864 :
866     REMark ''left file panel
868     REMark ''LONGLINE
870     ch% = 7
872     x% = panelWinWid%
874     y% = panelWinHeight%
876     px% = left%
878     py% = 2 * mainFountHeight% + 9
880     WINDOW# ch%, x%, y%, px%, py%
882     PAPER# ch%, ppr%
884     INK# ch%, ik%
886     BORDER# ch%, 1, brd%
888     CLS# ch%
890 :
892     REMark ''Right file panel
894     REMark ''LONGLINE
896     ch% = 8
898     x% = panelWinWid%
900     y% = panelWinHeight%
902     px% = panelWinWid% + left%
904     py% = 2 * mainFountHeight% + 9
906     WINDOW# ch%, x%, y%, px%, py%
908     PAPER# ch%, ppr%
910     INK# ch%, ik%
912     BORDER# ch%, 1, brd%
914     CLS# ch%
916 :
918     REMark ''Commands line
920     REMark ''LONGLINE
922     ch% = 9
924     x% = 2 * panelWinWid%
926     y% = mainFountHeight% + 2
928     px% = left%
930     py% = panelWinHeight% + 3 * mainFountHeight% + 7
932     WINDOW# ch%, x%, y%, px%, py%
934     PAPER# ch%, brd%
936     INK# ch%, White%
938     BORDER# ch%, 1, brd%
940     CLS# ch%
942 :
944     WriteCommands comWin%
946 :
948     crtPanel% = leftPanelWin%
950     IF reload% = 1
952         LShowLeftDir
954         LShowRightDir
956     ELSE
958         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
960         ListFiles RightFiles$, RStartPos%, RIndex%, 8
962     END IF
964 END DEFine
966 :
968 :
970 REMark ''-----------------------------------------------------------
972 DEFine PROCedure readConfig
974     LOCal a$(42), ch%
976 :
978     ConfigDrv$ = OPTION_CMD$ : REMark ''CMD$
980 :
982     IF ConfigDrv$ = "" THEN ConfigDrv$ = "dos1_qlc_"
984 :
986     a$ = ConfigDrv$ & "qlc20_cfg"
988 :
990     ch% = FOP_IN(a$)
992 :
994     IF ch% > 0
996         INPUT# ch%, MaxFiles%
998         INPUT# ch%, TempDir$
1000         INPUT# ch%, leftDir$
1002         INPUT# ch%, rightDir$
1004         INPUT# ch%, Qubide%
1006         INPUT# ch%, ClassicFont%
1008         INPUT# ch%, linelen%
1010         INPUT# ch%, rowno%
1012         INPUT# ch%, Xchangepath$
1014         INPUT# ch%, Xchangeprog$
1016         INPUT# ch%, EditPath$
1018         INPUT# ch%, Editprog$
1020         INPUT# ch%, QLColors%
1022         CLOSE# ch%
1024     ELSE
1026         CLS
1028         PRINT "Config file not found - using default values ! "
1030         MaxFiles% = 256
1032         TempDir$ = "win1_temp_"
1034         leftDir$ = "win1_"
1036         rightDir$ = "win1_"
1038         Qubide% = 0
1040         ClassicFont% = 1
1042         linelen% = 40
1044         rowno% = 20
1046         Xchangepath$ = ""
1048         Xchangeprog$ = ""
1050         EditPath$ = ""
1052         Editprog$ = ""
1054         QLColors = 1
1056         PAUSE 100
1058         CLS
1060     END IF
1062 :
1064     IF RMODE <= 8 OR QLColors% = 1
1066         IF VER$ = "HBA" AND RMODE > 4
1068             COLOUR_QL
1070             SetPalletteQL
1072         END IF
1074         ppr% = 0
1076         brd% = 4
1078         ik% = 7
1080         strp% = 7
1082         White% = 7
1084         Green% = 4
1086         PPR9a% = 2
1088         ppr9b% = 0
1090         TitleBorder% = 4
1092         TitleBk% = 0
1094     ELSE
1096         COLOUR_PAL
1098         ppr% = 4
1100         brd% = 13
1102         ik% = 1
1104         strp% = 13
1106         White% = 1
1108         Green% = 3
1110         PPR9a% = 72
1112         ppr9b% = 76
1114         TitleBorder% = 13
1116         TitleBk% = 4
1118     END IF
1120 :
1122     IF maxWinHgt% = 256 AND ClassicFont% > 1
1124         ClassicFont% = 1
1126     END IF
1128 END DEFine
1130 :
1132 :
1134 REMark ''------------------------------------------------------------
1136 DEFine PROCedure InitialiseVars
1138     titleWin% = 3
1140     leftPanelWin% = 7
1142     rightPanelWin% = 8
1144     comWin% = 9
1146     LSizedir% = 0
1148     LSizeFile% = 0
1150     crtPanel% = leftPanelWin%
1152     RSizedir% = 0
1154     RSizeFile% = 0
1156 :
1158     maxFNLen% = 36
1160 :
1162     _fLen% = maxFNLen% + 3
1164     _fTyp% = maxFNLen% + 7
1166     _fDat% = maxFNLen% + 9
1168     _fPar% = maxFNLen% + 13
1170     _fFlg% = maxFNLen% + 15
1172     _fMax% = maxFNLen% + 16
1174 :
1176     _dPar% = maxFNLen% + 3
1178     _dNxt% = maxFNLen% + 5
1180     _dChd% = maxFNLen% + 7
1182     _dFlg% = maxFNLen% + 9
1184     _dMax% = maxFNLen% + 10
1186 :
1188     DIM cmdText$(9, 9) : REMark ''Used by WriteCommands
1190     cmdText$(1) = CHR$(1) & " Info"
1192     cmdText$(2) = CHR$(2) & " Comp"
1194     cmdText$(3) = CHR$(3) & " View"
1196     cmdText$(4) = CHR$(4) & " Edit"
1198     cmdText$(5) = CHR$(5) & " Copy"
1200     cmdText$(6) = CHR$(6) & " Rename"
1202     cmdText$(7) = CHR$(7) & " MkDir"
1204     cmdText$(8) = CHR$(8) & " Delete"
1206     cmdText$(9) = CHR$(9) & " Exit"
1208 :
1210     initialDATAD$ = DATAD$
1212 :
1214     headSz% = 64
1216     headBuff = ALCHP(headSz%)
1218     IF headBuff < 0
1220         REMark ''LONGLINE
1222         StopWithError("Cannot allocate memory for File-header Buffer.")
1224     END IF
1226 :
1228 END DEFine
1230 :
1232 :
1234 REMark ''-----------------------------------------------------------
1236 DEFine PROCedure LShowLeftDir
1238     LOCal i%
1240 :
1242     REMark ''dim LeftFiles$(MaxFiles%,2,36)
1244     DIM LeftFiles$(MaxFiles%, _fMax%)
1246 :
1248     LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
1250 :
1252     IF LEN(leftDir$) = 5
1254         LStartPos% = 1
1256     ELSE
1258         LStartPos% = 0
1260     END IF
1262     LIndex% = LStartPos%
1264     LMinPos% = LStartPos%
1266     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
1268 END DEFine
1270 :
1272 :
1274 REMark ''-----------------------------------------------------------
1276 DEFine PROCedure LShowRightDir
1278     LOCal i%
1280 :
1282     DIM RightFiles$(MaxFiles%, _fMax%)
1284 :
1286     RSizedir% = 0
1288     RSizeFile% = 0
1290     LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
1292     IF LEN(rightDir$) = 5
1294         RStartPos% = 1
1296     ELSE
1298         RStartPos% = 0
1300     END IF
1302     RIndex% = RStartPos%
1304     RMinPos% = RStartPos%
1306     ListFiles RightFiles$, RStartPos%, RIndex%, 8
1308 END DEFine
1310 :
1312 :
1314 REMark ''-----------------------------------------------------------
1316 REMark ''reference FileList$(0,0,0)
1318 REFERENCE FileList$(0, 0)
1320 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
1322     LOCal a$(linelen%), i%, size%, EndPos%
1324     LOCal nochars%, x%, DFlen1%, DFLen2%
1326 :
1328     IF ch% = 7
1330         size% = LSizedir% + LSizeFile%
1332     ELSE
1334         size% = RSizedir% + RSizeFile%
1336     END IF
1338     EndPos% = StartPos% + rowno% - 1
1340     IF EndPos% > size% THEN EndPos% = size%
1342 :
1344     CLS# ch%
1346     FOR i% = StartPos% TO EndPos%
1348         a$ = GetFNam$(FileList$, i%)
1350         DFlen1% = LEN(a$)
1352         DFLen2% = LEN(GetFLen(FileList$, i%))
1354         IF GetFFlg%(FileList$, i%) MOD 2 = 1
1356             x% = 3
1358             IF DFlen1% > linelen% - x%
1360                 a$ = a$(TO linelen% - x% - 2)
1362                 a$ = a$ & ".."
1364             END IF
1366             a$ = a$ & " ->"
1368             a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
1370         ELSE
1372             x% = 9
1374             IF DFlen1% > linelen% - x%
1376                 a$ = a$(TO linelen% - x% - 2)
1378                 a$ = a$ & ".."
1380             END IF
1382             REMark ''LONGLINE
1384             a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1)
1386             a$ = a$ & GetFLen(FileList$,i%)
1388         END IF
1390 :
1392         INK# ch%, ik%
1394         IF i% = Index%
1396             IF crtPanel% = ch%
1398                 STRIP# ch%, strp%
1400                 IF GetFFlg%(FileList$, i%) > 1
1402                     INK# ch%, 2
1404                 ELSE
1406                     INK# ch%, ppr%
1408                 END IF
1410                 PRINT# ch%, a$
1412                 STRIP# ch%, ppr%
1414             ELSE
1416                 PRINT# ch%, a$
1418             END IF
1420         ELSE
1422             IF GetFFlg%(FileList$, i%) > 1
1424                 INK# ch%, 2
1426             ELSE
1428                 INK# ch%, ik%
1430             END IF
1432             PRINT# ch%, a$
1434         END IF
1436     END FOR i%
1438 END DEFine
1440 :
1442 :
1444 REMark ''-----------------------------------------------------------
1446 DEFine PROCedure MainLoop
1448     LOCal a$, x%, y$
1450 :
1452     REPeat loop
1454         a$ = INKEY$(-1)
1456         x% = CODE(a$)
1458         dbg(x%)
1460 :
1462         SELect ON x%
1464 :
1466           = KCtrlW:
1468               WMOV
1470 :
1472           = KCtrlA:
1474                 REMark ''LONGLINE
1476               MessageWnd 216, 60, 3, "        QL COMMANDER v" & qlcVer$ & CHR$(10) & " Andrei Tenu & Martyn Hill - 2019" & CHR$(10) & "    GNU General Public License"
1478 :
1480           = KDown:
1482               IF crtPanel% = 7
1484                   REMark ''LONGLINE
1486                   MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1488               ELSE
1490                   REMark ''LONGLINE
1492                   MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1494               END IF
1496 :
1498           = KUp:
1500               IF crtPanel% = 7
1502                   REMark ''LONGLINE
1504                   MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1506               ELSE
1508                   REMark ''LONGLINE
1510                   MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1512               END IF
1514 :
1516           = KPageDown, KShiftDown:
1518               IF crtPanel% = 7
1520                   MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
1522               ELSE
1524                   MovePageDown RightFiles$, RStartPos%, RIndex%, 8
1526               END IF
1528 :
1530           = KTab:
1532               ChangePanel
1534 :
1536           = KCtrlX, KF10ShiftF5:
1538               RETurn
1540 :
1542           = KSpace:
1544               SelectFile
1546 :
1548           = KPageUp, KShiftUp:
1550               IF crtPanel% = 7
1552                   MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
1554               ELSE
1556                   MovePageUp RightFiles$, RStartPos%, RIndex%, 8
1558               END IF
1560 :
1562           = KEnter:
1564               OnEnter
1566 :
1568           = KShiftEnter:
1570               LRUNBasic
1572 :
1574           = KBackSpace
1576               IF crtPanel% = 7
1578                   MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1580                   IF GetFNam$(LeftFiles$, LIndex%) = ".."
1582                       OnEnter
1584                   ELSE
1586                       BEEP 1390, 20
1588                   END IF
1590               ELSE
1592                   MoveTop RightFiles$, RStartPos%, RIndex%, 8
1594                   IF GetFNam$(RightFiles$,RIndex%) = ".."
1596                       OnEnter
1598                   ELSE
1600                       BEEP 1390, 20
1602                   END IF
1604               END IF
1606 :
1608           = KHome, KCtrlUp:
1610               IF crtPanel% = 7
1612                   MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1614               ELSE
1616                   MoveTop RightFiles$, RStartPos%, RIndex%, 8
1618               END IF
1620 :
1622           = KEnd, KCtrlDown:
1624               IF crtPanel% = 7
1626                   MoveLast LeftFiles$, LStartPos%, LIndex%, 7
1628               ELSE
1630                   MoveLast RightFiles$, RStartPos%, RIndex%, 8
1632               END IF
1634 :
1636           = KCtrl1, KCtrlD:
1638               InputDir 5
1640 :
1642           = KCtrl2, KCtrlR:
1644               InputDir 6
1646 :
1648           = KF3:
1650               ViewFile
1652 :
1654           = KF5:
1656               CopyFiles
1658 :
1660           = KF4:
1662               DoEdit
1664 :
1666           = KF6ShiftF1:
1668               RenameFile
1670 :
1672           = KF8ShiftF3:
1674               DeleteFiles
1676 :
1678           = KF1:
1680               ShowInfo
1682 :
1684           = KF7ShiftF2:
1686               CreateDir
1688 :
1690           REMark ''Find next matching File/Dir starting with a$
1692           =65  TO  90: JumpTo x%, 1
1694           =160 TO 171: JumpTo x%, 1
1696           =97  TO 122: JumpTo x%, 2
1698           =128 TO 139: JumpTo x%, 2
1700           =48  TO  57: JumpTo x%, 0
1702 :
1704           = KPlus, KEqual:
1706               SelectAll
1708 :
1710           = KMinus, KUnderscore:
1712               UnSelectAll
1714 :
1716           = KF9ShiftF4:
1718               DrawWindows 0
1720 :
1722           = KF8ShiftF3:
1724               CompareDirs
1726 :
1728           = KCtrlI:
1730               InvertSelection
1732         END SELect
1734     END REPeat loop
1736 END DEFine
1738 :
1740 :
1742 REMark ''-----------------------------------------------------------
1744 REMark ''a% = code of char to find
1746 REMark ''what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
1748 REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
1750 DEFine FuNction FindFirst%(a%, what%)
1752     LOCal i%, istart%, iend%, found%
1754 :
1756     found% = 0
1758 :
1760     IF crtPanel% = 7
1762 :
1764         IF what% < 2
1766             istart% = 1
1768         ELSE
1770             istart% = LSizedir% + 1
1772         END IF
1774 :
1776         IF what% = 1
1778             iend% = LSizedir%
1780         ELSE
1782             iend% = LSizedir% + LSizeFile%
1784         END IF
1786 :
1788         IF istart% > iend% THEN RETurn LIndex%
1790 :
1792         IF what% > 0
1794             FOR i% = istart% TO iend%
1796               IF CODE(GetFNam$(LeftFiles$, i%)) >= a%
1798                   found% = 1
1800                   EXIT i%
1802               END IF
1804               NEXT i%
1806             END FOR i%
1808         ELSE
1810             FOR i% = LIndex% + 1 TO iend%
1812                 IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1814                     found% = 1
1816                     EXIT i%
1818                 END IF
1820                 NEXT i%
1822             END FOR i%
1824             IF found% = 0
1826                 FOR i% = istart% TO LIndex%
1828                     IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1830                         found% = 1
1832                         EXIT i%
1834                     END IF
1836                     NEXT i%
1838                 END FOR i%
1840             END IF
1842             IF found% = 0 THEN i% = istart%
1844         END IF
1846 :
1848         REMark ''LONGLINE
1850         IF i% <= iend% THEN RETurn i% : ELSE RETurn iend%
1852 :
1854     ELSE
1856 :
1858         IF what% < 2
1860             istart% = 1
1862         ELSE
1864             istart% = RSizedir% + 1
1866         END IF
1868 :
1870         IF what% = 1
1872             iend% = RSizedir%
1874         ELSE
1876             iend% = RSizedir% + RSizeFile%
1878         END IF
1880 :
1882         IF istart% > iend% THEN RETurn RIndex%
1884 :
1886         IF what% > 0
1888             FOR i% = istart% TO iend%
1890                 IF CODE(GetFNam$(RightFiles$, i%)) >= a%
1892                     EXIT i%
1894                 END IF
1896                 NEXT i%
1898             END FOR i%
1900         ELSE
1902             FOR i% = RIndex% + 1 TO iend%
1904                 IF CODE(GetFNam$(RightFiles$, i%)) = a%
1906                     found% = 1
1908                     EXIT i%
1910                 END IF
1912                 NEXT i%
1914             END FOR i%
1916             IF found% = 0
1918                 FOR i% = istart% TO RIndex%
1920                     IF CODE(GetFNam$(RightFiles$, i%)) = a%
1922                         found% = 1
1924                         EXIT i%
1926                     END IF
1928                     NEXT i%
1930                 END FOR i%
1932             END IF
1934             IF found% = 0 THEN i% = istart%
1936         END IF
1938 :
1940         REMark ''LONGLINE
1942         IF i% <= iend% THEN RETurn i% : ELSE RETurn iend%
1944 :
1946     END IF
1948 :
1950 END DEFine
1952 :
1954 :
1956 REMark ''-----------------------------------------------------------
1958 DEFine PROCedure JumpTo(a%, what%)
1960     LOCal x%, start%
1962 :
1964     IF crtPanel% = 7
1966         IF LSizedir% + LSizeFile% = 0 THEN RETurn
1968     ELSE
1970         IF RSizedir% + RSizeFile% = 0 THEN RETurn
1972     END IF
1974 :
1976     x% = FindFirst%(a%, what%)
1978 :
1980     IF crtPanel% = 7
1982         IF x% = LIndex% THEN RETurn
1984         IF (x% >= LStartPos%) AND (x% < LStartPos% + 20)
1986             REMark ''LONGLINE
1988             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
1990             LIndex% = x%
1992             REMark ''LONGLINE
1994             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 1
1996         ELSE
1998             LIndex% = x%
2000             x% = x% + (LMinPos% = 0)
2002             page% = x% DIV rowno%
2004             IF x% MOD rowno% > 0 THEN page% = page% + 1
2006             LStartPos% = (page% - 1) * rowno% + LMinPos%
2008             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2010         END IF
2012     ELSE
2014         IF x% = RIndex% THEN RETurn
2016         IF x% >= RStartPos% AND x% < RStartPos% + rowno%
2018             REMark ''LONGLINE
2020             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2022             RIndex% = x%
2024             REMark ''LONGLINE
2026             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2028         ELSE
2030             RIndex% = x%
2032             x% = x% + (RMinPos% = 0)
2034             page% = x% DIV rowno%
2036             IF x% MOD rowno% > 0 THEN page% = page% + 1
2038             RStartPos% = (page% - 1) * rowno% + RMinPos%
2040             ListFiles RightFiles$, RStartPos%, RIndex%, 8
2042         END IF
2044     END IF
2046 END DEFine
2048 :
2050 :
2052 REMark ''-----------------------------------------------------------
2054 REMark ''String Quick Search & Insert
2056 REMark ''(c)tcat, 2017 Tomas Kral
2058 REMark ''modified by Andrei Tenu 2018
2060 :
2062  REMark ''FileLis$ = name of array to load into
2064  REMark ''no% = start index
2066  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
2068  REMark ''Quick search returns:
2070  REMark ''0=not found, 1=found, id%=position
2072 :
2074 REMark ''reference FileList$(0,0,0),id%
2076 REFERENCE FileList$(0, 0), id%
2078 DEFine FuNction Find%(str$, id%, FileList$, no%, size%)
2080     LOCal top%, bot%, mid%, nextFNam$(maxFNLen%)
2082 :
2084     top% = no%
2086     bot% = size%
2088 :
2090     REPeat find_loop
2092         mid% = (bot% + top%) DIV 2
2094         nextFNam$ = GetFNam$(FileList$, mid%)
2096 :
2098         IF top% > bot%
2100             id% = mid% + 1
2102             RETurn 0
2104         ELSE
2106             IF str$ = nextFNam$
2108                 id% = mid%
2110                 RETurn 1
2112             ELSE
2114                 IF str$ > nextFNam$
2116                     top% = mid% + 1
2118                 ELSE
2120                     IF str$ < nextFNam$
2122                         bot% = mid% - 1
2124                     END IF
2126                 END IF
2128             END IF
2130         END IF
2132     END REPeat find_loop
2134 END DEFine
2136 :
2138 :
2140 REMark ''-----------------------------------------------------------
2142  REMark ''Inserts String at position id%
2144  REMark ''Returns 2=ok, -1=array full
2146 :
2148 REMark ''reference FileList$(0,0,0),r_SizeDir%, r_SizeFile%
2150 REFERENCE FileList$(0, 0), r_SizeDir%, r_SizeFile%
2152 DEFine FuNction Insert%(str$, id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
2154     LOCal i%, size%
2156 :
2158     size% = r_SizeDir% + r_SizeFile%
2160     IF size% >= MaxFiles% THEN RETurn -1
2162     FOR i% = size% TO id% STEP -1
2164         CopyRec FileList$, i% TO FileList$, i%+1
2166     END FOR i%
2168 :
2170     PutFNam FileList$, id%, str$
2172     PutFLen FileList$, id%, fLength$
2174     PutFFlg FileList$, id%, DoF%
2176 :
2178     IF DoF% = 1
2180         r_SizeDir% = r_SizeDir% + 1
2182     ELSE
2184         r_SizeFile% = r_SizeFile% + 1
2186     END IF
2188 :
2190     RETurn 2
2192 END DEFine
2194 :
2196 :
2198 REMark ''End of String Quick Search & Insert -----------------------
2200 :
2202 :
2204 REMark ''-----------------------------------------------------------
2206 REMark ''reference dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
2208 REFERENCE dev$(0), FileList$(0, 0), r_SizeDir%, r_SizeFile%
2210 DEFine PROCedure LoadDir(dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
2212     LOCal ch%, i, head_start, totrim, flength, file$, ftype
2214     LOCal size2%, res, DirOrFile%, id%, filelen$,k$, no_files
2216 :
2218     CLS# Chan%
2220     INK# Chan%, 7
2222     PRINT# Chan%, "...Loading File List ..."
2224 :
2226     IF dev$(LEN(dev$)) <> "_" THEN dev$ = dev$ & "_"
2228 :
2230     REMark ''LONGLINE
2232     IF Chan% = 7 THEN PRINT# 5, dev$ : ELSE PRINT# 6, dev$
2234 :
2236     IF DirExists%(dev$) = 0
2238         BEEP 1390, 100
2240         PRINT# Chan%, "Cannot open directory " & dev$
2242         RETurn
2244     END IF
2246 :
2248     r_SizeDir% = 0
2250     r_SizeFile% = 0
2252     totrim = LEN(dev$) - 4
2254     IF totrim <= 0 THEN totrim = 1
2256 :
2258     PutFNam FileList$, 0, ".."
2260     PutFLen FileList$, 0, 0
2262     PutFFlg FileList$, 0, 1
2264 :
2266     head_start = 0
2268     i = 1
2270     ch% = FOP_DIR(dev$)
2272     REMark ''use _+ as #, __+ as \ ???
2274     no_files = FLEN(#ch%) DIV 64
2276 :
2278     FOR listing = 1 TO no_files
2280         SET_POSITION# ch%, head_start + 0
2282         REMark ''use _+ as #, __+ as \ ???
2284         flength = LONGINTEGER(INPUT$(#ch%, 4)) - 64
2286         REMark ''use _+ as #, __+ as \ ???
2288         faccess = CODE(INKEY$(#ch%))
2290         REMark ''use _+ as #, __+ as \ ???
2292         ftype = CODE(INKEY$(#ch%))
2294         IF flength >= 0
2296             SET_POSITION #ch%, head_start + 14
2298             REMark ''use _+ as #, __+ as \ ???
2300             file$ = GET$(#ch%) : REMark ''FIXME get$ exists ???
2302             IF LEN(file$) > 0
2304                 file$ = file$(totrim TO)
2306                 filelen$ = flength
2308                 SET_POSITION #ch%, head_start + 52
2310                 REMark ''use _+ as #, __+ as \ ???
2312                 fdate = LONGINTEGER(INPUT$(#ch%, 4))
2314                 IF ftype < 255
2316                     size2% = r_SizeDir% + r_SizeFile%
2318                     file$ = LOWER$(file$)
2320                     REMark ''LONGLINE
2322                     res = Find%(file$, id%, FileList$, r_SizeDir% + 1, size2%)
2324                     DirOrFile% = 0
2326                 ELSE
2328                     file$ = UPPER$(file$)
2330                     REMark ''LONGLINE
2332                     res = Find%(file$, id%, FileList$, 1, r_SizeDir%)
2334                     DirOrFile% = 1
2336                 END IF
2338                 i = i + 1
2340 :
2342                 REMark ''k$="":
2344                 REMark ''if flength>1023 then
2346                 REMark '' flength=INT(flength/1024+.5):k$="K"
2348                 REMark '' if flength>1023 then
2350                 REMark ''   flength=INT(flength/1024+.5):k$="M"
2352                 REMark '' endif
2354                 REMark ''endif
2356                 REMark ''filelen$=flength&k$
2358                 IF res = 0
2360                     REMark ''LONGLINE
2362                    res = Insert%(file$, id%, FileList$, DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$)
2364                 END IF
2366                 REMark ''FIXME mixworx : or then ??
2368                 IF res = -1 : EXIT listing
2370             END IF
2372         END IF
2374         head_start = head_start + 64
2376     END FOR listing
2378     CLOSE# ch%
2380 END DEFine
2382 :
2384 :
2386 REMark ''-----------------------------------------------------------
2388 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2390 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2392 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2394     LOCal size%, idx%
2396 :
2398     size% = SizeFile% + SizeDir%
2400     IF r_Index% > size% THEN RETurn
2402     REMark ''LONGLINE
2404     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2406     r_Index% = r_Index% + 1
2408     IF r_Index% > size% THEN r_Index% = size%
2410     IF r_Index% > r_StartPos% + rowno% - 1
2412         SCROLL# crtPanel%, - mainFountHeight%
2414         r_StartPos% = r_StartPos% + 1
2416     END IF
2418     ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
2420 END DEFine
2422 :
2424 :
2426 REMark ''-----------------------------------------------------------
2428 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2430 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2432 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2434     LOCal size%, idx%
2436 :
2438     size% = SizeFile% + SizeDir%
2440     IF r_Index% > size%  THEN RETurn
2442     REMark ''LONGLINE
2444     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2446     r_Index% = r_Index% - 1
2448     REMark ''FIXME mixworx : or then ??
2450     IF r_Index%<MinPos% THEN : r_Index% = MinPos%
2452     IF r_Index% < r_StartPos%
2454         SCROLL# crtPanel%, mainFountHeight%
2456         r_StartPos% = r_StartPos% - 1
2458     END IF
2460     REMark ''LONGLINE
2462     ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 1
2464 END DEFine
2466 :
2468 :
2470 REMark ''-----------------------------------------------------------
2472 REMark ''reference FileList$(0,0,0)
2474 REFERENCE FileList$(0, 0)
2476 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
2478     LOCal a$, x%, DFlen1%, DFLen2%
2480 :
2482     a$ = GetFNam$(FileList$, Index%)
2484     DFlen1% = LEN(a$)
2486     DFLen2% = LEN(GetFLen(FileList$, Index%))
2488 :
2490     IF GetFFlg%(FileList$, Index%) MOD 2 = 1
2492         x% = 3
2494         IF DFlen1% > linelen% - x%
2496             a$ = a$(TO linelen% - x% - 2)
2498             a$ = a$ & ".."
2500         END IF
2502         a$ = a$ & " ->"
2504         a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
2506     ELSE
2508         x% = 9
2510         IF DFlen1% > linelen% - x%
2512             a$ = a$(TO linelen% - x% - 2)
2514             a$ = a$ & ".."
2516         END IF
2518         a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1)
2520         a$ = a$ & GetFLen(FileList$, Index%)
2522     END IF
2524     IF SoH% = 1
2526         STRIP# crtPanel%, strp%
2528         INK# crtPanel%, 0
2530         IF GetFFlg%(FileList$, Index%) > 1
2532             INK# crtPanel%, 2
2534         ELSE
2536             INK# crtPanel%, 0
2538         END IF
2540         AT# crtPanel%, Linepos%, 0
2542         PRINT# crtPanel%, a$;
2544         STRIP# crtPanel%, ppr%
2546         INK# crtPanel%, ik%
2548     ELSE
2550         IF GetFFlg%(FileList$, Index%) > 1
2552             INK# crtPanel%, 2
2554         ELSE
2556             INK# crtPanel%, ik%
2558         END IF
2560         AT# crtPanel%, Linepos%, 0
2562         PRINT# crtPanel%, a$;
2564     END IF
2566 END DEFine
2568 :
2570 :
2572 REMark ''-----------------------------------------------------------
2574 DEFine PROCedure ChangePanel
2576     IF crtPanel% = 7
2578         IF LIndex% <= LSizedir% + LSizeFile%
2580             REMark ''LONGLINE
2582             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
2584         END IF
2586         crtPanel% = 8
2588         IF RIndex% <= RSizedir% + RSizeFile%
2590             REMark ''LONGLINE
2592             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2594         END IF
2596         BORDER# 8, 1, brd%
2598         BORDER# 7, 1, brd%, 1 ,3
2600     ELSE
2602         IF RIndex% <= RSizedir% + RSizeFile%
2604             REMark ''LONGLINE
2606             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2608         END IF
2610         crtPanel% = 7
2612         IF LIndex% <= LSizedir% + LSizeFile%
2614             REMark ''LONGLINE
2616             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 1
2618         END IF
2620         BORDER# 7, 1, brd%
2622         BORDER# 8, 1, brd%, 1, 3
2624     END IF
2626 END DEFine
2628 :
2630 :
2632 REMark ''-----------------------------------------------------------
2634 DEFine PROCedure SelectFile
2636     IF crtPanel% = 7
2638         REMark ''LONGLINE
2640         PutFFlg LeftFiles$, LIndex%, GetFFlg%(LeftFiles$, LIndex%) ^^ 2
2642         REMark ''LONGLINE
2644         ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
2646     ELSE
2648         REMark ''LONGLINE
2650         PutFFlg RightFiles$, RIndex%, GetFFlg%(RightFiles$, RIndex%) ^^ 2
2652         REMark ''LONGLINE
2654         ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2656     END IF
2658 END DEFine
2660 :
2662 :
2664 REMark ''-----------------------------------------------------------
2666 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2668 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2670 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
2672     LOCal size%, x%
2674 :
2676     IF ch% = 7
2678         size% = LSizedir% + LSizeFile%
2680     ELSE
2682         size% = RSizedir% + RSizeFile%
2684     END IF
2686     IF r_Index% > size% THEN RETurn
2688     x% = r_StartPos% + 20
2690     IF x% > size% THEN RETurn
2692     r_StartPos% = x%
2694     r_Index% = r_StartPos%
2696     ListFiles FileList$, r_StartPos%, r_Index%, ch%
2698 END DEFine
2700 :
2702 :
2704 REMark ''-----------------------------------------------------------
2706 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2708 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2710 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
2712     LOCal top%, x%, size%
2714 :
2716     IF ch% = 7
2718         top% = LMinPos%
2720         size% = LSizeFile% + LSizedir%
2722     ELSE
2724         top% = RMinPos%
2726         size% = RSizeFile% + RSizedir%
2728     END IF
2730     IF r_Index% > size% THEN RETurn
2732     x% = r_StartPos% - 20
2734     IF x% < top% THEN x% = top%
2736     r_StartPos% = x%
2738     r_Index% = r_StartPos%
2740     ListFiles FileList$, r_StartPos%, r_Index%, ch%
2742 END DEFine
2744 :
2746 :
2748 REMark ''-----------------------------------------------------------
2750 REMark ''reference FileList$(0,0,0)
2752 REFERENCE FileList$(0, 0)
2754 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
2756     LOCal a$, size%, d$, x%, page%
2758 :
2760     IF ch% = 7
2762         size% = LSizeFile% + LSizedir%
2764         d$ = leftDir$
2766     ELSE
2768         size% = RSizeFile% + RSizedir%
2770         d$ = rightDir$
2772     END IF
2774     IF Index% > size% THEN RETurn
2776     IF GetFFlg%(FileList$, Index%) MOD 2 <> 1 THEN RETurn
2778 :
2780     IF GetFNam$(FileList$, Index%) = ".."
2782         a$ = GetParentDir$(ch%)
2784         IF LEN(d$) > LEN(a$)
2786             d$ = d$(LEN(a$) + 1 TO)
2788             IF d$(LEN(d$)) = "_" THEN d$ = d$(1 TO LEN(d$) - 1)
2790             IF crtPanel% = 7
2792                 DIM LeftFiles$(MaxFiles%, _fMax%)
2794                 leftDir$ = a$
2796                 LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
2798                 IF LEN(leftDir$) = 5
2800                     LMinPos% = 1
2802                 ELSE
2804                     LMinPos% = 0
2806                 END IF
2808                 IF Find%(d$, id%, LeftFiles$, 1, LSizedir%) = 1
2810                     LIndex% = id%
2812                     x% = id% + (LMinPos% = 0)
2814                     page% = x% DIV rowno%
2816                     IF x% MOD rowno% > 0 THEN page% = page% + 1
2818                     LStartPos% = (page% - 1) * rowno% + LMinPos%
2820                     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2822                 ELSE
2824                     d$ = ""
2826                 END IF
2828             ELSE
2830                 DIM RightFiles$(MaxFiles%, _fMax%)
2832                 rightDir$ = a$
2834                 LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
2836                 IF LEN(rightDir$) = 5
2838                     RMinPos% = 1
2840                 ELSE
2842                     RMinPos% = 0
2844                 END IF
2846                 IF Find%(d$, id%, RightFiles$, 1, RSizedir%) = 1
2848                     RIndex% = id%
2850                     x% = id% + (RMinPos% = 0)
2852                     page% = x% DIV rowno%
2854                     IF x% MOD rowno% > 0 THEN page% = page% + 1
2856                     RStartPos% = (page% - 1) * rowno% + RMinPos%
2858                     ListFiles RightFiles$, RStartPos%, RIndex%, 8
2860                 ELSE
2862                     d$ = ""
2864                 END IF
2866             END IF
2868         ELSE
2870             d$ = ""
2872         END IF
2874     ELSE
2876         d$ = ""
2878         IF ch% = 7
2880             a$ = leftDir$ & GetFNam$(FileList$, Index%)
2882         ELSE
2884             a$ = rightDir$ & GetFNam$(FileList$, Index%)
2886         END IF
2888     END IF
2890     IF LEN(d$) = 0
2892         IF ch% = 7
2894             leftDir$ = a$
2896             LShowLeftDir
2898         ELSE
2900             rightDir$ = a$
2902             LShowRightDir
2904         END IF
2906     END IF
2908 END DEFine
2910 :
2912 :
2914 REMark ''-----------------------------------------------------------
2916 DEFine FuNction GetParentDir$(ch%)
2918     LOCal i%, dir$
2920 :
2922     IF ch% = 7
2924         dir$ = leftDir$
2926     ELSE
2928         dir$ = rightDir$
2930     END IF
2932     FOR i% = LEN(dir$) - 1 TO 5 STEP -1
2934         IF dir$(i%) = "_"
2936             IF FTEST(dir$(1 TO i%)) = 0
2938                 REMark ''use _+ as #, __+ as \ ???
2940                 IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
2942             END IF
2944         END IF
2946     END FOR i%
2948     dir$ = dir$(1 TO i%)
2950     RETurn dir$
2952 END DEFine
2954 :
2956 :
2958 REMark ''------------------------------------------------------------
2960 DEFine PROCedure InputDir(ch%)
2962     LOCal a$, olddir$
2964 :
2966     PAPER# ch%, 0
2968     INK# ch%, 7
2970     CLS# ch%
2972 :
2974     IF ch% = 5
2976         olddir$ = leftDir$
2978     ELSE
2980         olddir$ = rightDir$
2982     END IF
2984 :
2986     REMark ''use _+ as #, __+ as \ ???
2988     a$ = EDIT$(#ch%, olddir$, 36)
2990     CLS# ch%
2992     PAPER# ch%, White%
2994     INK# ch%, 0
2996     CLS# ch%
2998 :
3000     IF a$ = "" THEN a$ = olddir$
3002     IF a$(LEN(a$)) <> "_" THEN a$ = a$ & "_"
3004     IF DirExists%(a$) = 0
3006         BEEP 1390, 20
3008         PRINT# ch%, olddir$
3010         RETurn
3012     END IF
3014 :
3016     IF ch% = 5
3018         IF crtPanel% = 8
3020             REMark ''LONGLINE
3022             ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
3024         END IF
3026         leftDir$ = a$
3028         crtPanel% = 7
3030         LShowLeftDir
3032         BORDER# 7, 1, brd%
3034         BORDER# 8, 1, brd%, 1, 3
3036     ELSE
3038         IF crtPanel% = 7
3040             REMark ''LONGLINE
3042             ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
3044         END IF
3046         rightDir$ = a$
3048         crtPanel% = 8
3050         LShowRightDir
3052         BORDER# 8, 1, brd%
3054         BORDER# 7, 1, brd%, 1, 3
3056     END IF
3058 :
3060 END DEFine
3062 :
3064 :
3066 REMark ''----------------------------------------------------------
3068 DEFine PROCedure ViewFile
3070     LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%
3072     LOCal left%, windef$, wid%, hgt%, top%
3074 :
3076     IF crtPanel% = 7
3078         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
3080         a$ = GetFNam$(LeftFiles$, LIndex%)
3082     ELSE
3084         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
3086         a$ = GetFNam$(RightFiles$, RIndex%)
3088     END IF
3090     IF a$ == ".." OR a$ == "<un-named>" OR IsDir%() = 1
3092         RETurn
3094     END IF
3096     REMark ''now get file extension
3098     x% = LEN(a$)
3100     FOR i% = 0 TO x% - 1
3102         IF a$(x% - i%) == "_" OR a$(x% - i%) == "."
3104             EXIT i%
3106         END IF
3108     END FOR i%
3110     IF i% > 0
3112         ext$ = a$(x% - i% + 1 TO x%)
3114     ELSE
3116         ext$ = ""
3118     END IF
3120     IF crtPanel% = 7
3122         a$ = leftDir$ & a$
3124     ELSE
3126         a$ = rightDir$ & a$
3128     END IF
3130     ext$ = LOWER$(ext$)
3132     x% = 0
3134     IF ext$ = "fnt" THEN x% = 1
3136     IF ext$ = "fat" THEN x% = 2
3138     IF ext$ = "scr" THEN x% = 3
3140     IF ext$ = "doc" THEN x% = 4
3142     IF ext$ = "zip" THEN x% = 5
3144     IF x% <> 3
3146         IF x% = 1 OR x% = 2
3148             left% = (maxWinWid% - 448) DIV 2 - 2
3150             wid% = 452
3152             hgt% = 230
3154             REMark ''LONGLINE
3156             top% = (panelWinHeight% + 2 * mainFountHeight% + 7 - hgt%) DIV 2 + 14
3158             windef$ = "scr_452x230a" & left% & "x" & top%
3160             ch% = FOPEN(windef$)
3162             PAPER# ch%, 0
3164             INK #ch%, White%
3166             OUTLN# ch%, 452, 230, left%, top%
3168             BORDER# ch%, 1, 2
3170             CLS# ch%
3172             windef$ = "scr_452x12a" & left% & "x" & top%
3174             ch1% = FOPEN(windef$)
3176             BORDER# ch1%, 1, 2
3178             PAPER# ch1%, 0, 2, 1
3180             CLS# ch1%
3182             PAPER# ch1%,0
3184             INK# ch1%, White%
3186             AT# ch1%, 0, 37 - (LEN(a$) + 5) DIV 2
3188             PRINT# ch1%, "View " & a$
3190             left% = left% + 2
3192             windef$ = "scr_448x204a" & left% & "x" & (top% + 12)
3194             ch2% = FOPEN(windef$)
3196             PAPER# ch2%, 0
3198             INK# ch2%, Green%
3200         ELSE
3202             REMark ''LONGLINE
3204             IF maxWinWid% > 600 THEN wid% = 600 : ELSE wid% = 452
3206             hgt% = panelWinHeight% + 27
3208             left% = (maxWinWid% - wid%) DIV 2 - 2
3210             top% = mainFountHeight% + 4
3212             REMark ''LONGLINE
3214             windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x" & top%
3216             ch% = FOPEN(windef$)
3218             PAPER# ch%, 0
3220             INK# ch%, White%
3222             OUTLN# ch%, wid%, hgt%, left%, top%
3224             BORDER# ch%, 1, 2
3226             CLS# ch%
3228             REMark ''LONGLINE
3230             windef$ = "scr_" & wid% & "x12a" & left% & "x" & top%
3232             ch1% = FOPEN(windef$)
3234             BORDER# ch1%, 1, 2
3236             PAPER# ch1%, 0, 2, 1
3238             CLS# ch1%
3240             PAPER# ch1%, 0
3242             INK# ch1%, White%
3244             CURSOR# ch1%,(wid% - (LEN(a$) + 5) * 6) DIV 2, 0
3246             PRINT# ch1%, "View " & a$
3248             left% = left% + 2
3250             REMark ''LONGLINE
3252             windef$ = "scr_" & (wid% - 4) & "x" & (hgt% - 26) & "a" & left% & "x" & (top% + 12)
3254             ch2% = FOPEN(windef$)
3256             PAPER# ch2%, 0
3258             INK# ch2%, Green%
3260         END IF
3262 :
3264     END IF
3266     SELect ON x%
3268         = 1:
3270             ViewFont a$, 1, ch2%
3272 :
3274         = 2:
3276             ViewFont a$, 2, ch2%
3278 :
3280         = 3:
3282             ViewImage a$, 4 : Set78CharSet
3284 :
3286         = 4:
3288             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3290             PAPER# 0, Green%
3292             INK# 0, 0
3294             CLS# 0
3296 :
3298             IF IsQuillDoc%(a$) = 1
3300                 IF FTEST(ConfigDrv$ & "quill_view") = 0
3302                     REMark ''LONGLINE
3304                     EW ConfigDrv$ & "quill_view", #ch2%; "-t " & a$ & " " & TempDir$ & "quill_tmp"
3306                     IF FTEST(TempDir$ & "quill_tmp") = 0
3308                         IF mainFountBase > 0 AND wid% < 600
3310                             CHAR_USE# ch2%, mainFountBase, 0
3312                             CHAR_INC# ch2%, 5, 10
3314                         END IF
3316                         MORE# ch2%, TempDir$ & "quill_tmp"
3318                         DELETE TempDir$ & "quill_tmp"
3320                     END IF
3322                 ELSE
3324                     PRINT# ch2%, "Cannot find quill_view"
3326                 END IF
3328             ELSE
3330                 MORE# ch2%, a$
3332             END IF
3334 :
3336         =5:
3338             REMark ''LONGLINE
3340             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3342             PAPER# 0, Green%
3344             INK# 0, 0
3346             CLS# 0
3348             IF IsZipFile%(a$) = 1
3350                 IF FTEST(ConfigDrv$ & "unzip") = 0
3352                     ch3% = FOP_OVER(TempDir$ & "zip_tmp")
3354                     IF ch3% > 0
3356                         REMark ''LONGLINE
3358                         EW ConfigDrv$&"unzip", #ch3%, #ch3%,#ch3%;"-lqq "&a$
3360                         CLOSE# ch3%
3362                         MORE# ch2%, TempDir$ & "zip_tmp"
3364                         DELETE TempDir$ & "zip_tmp"
3366                     ELSE
3368                         REMark ''LONGLINE
3370                         PRINT# ch2%, "Cannot create temporary file"
3372                     END IF
3374                 ELSE
3376                     PRINT# ch2%, "Cannot find unzip"
3378                 END IF
3380             ELSE
3382                 MORE# ch2%, a$
3384             END IF
3386 :
3388         = REMAINDER :
3390             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
3392             PAPER# 0, Green%
3394             INK# 0, 0
3396             CLS# 0
3398             MORE# ch2%, a$
3400     END SELect
3402 :
3404     IF x% <> 3
3406         CHAR_USE# ch2%, 0, 0
3408         CLS# ch1%
3410         CLS# ch2%
3412         CLOSE# ch2%
3414         CLOSE# ch1%
3416         WINDOW# 0, 488, 23, 12, 233
3418         PAPER# 0, 0
3420         INK# 0, White%
3422         OUTLN# ch%, wid%, hgt%, left%, top%
3424         CLOSE# ch%
3426     END IF
3428 END DEFine
3430 :
3432 :
3434 REMark ''----------------------------------------------------------
3436 DEFine PROCedure ViewFont(file$, type%, ch%)
3438     LOCal lng, i, base, type$(6)
3440 :
3442     REMark ''use _+ as #, __+ as \ ???
3444     lng = FLEN(\file$)
3446     IF lng > 0
3448         AT# ch%, 0, 0
3450         PRINT# ch%, "Font: " & file$; "      ";
3452         AT# ch%, 0, 44
3454         PRINT# ch%, "Font size = "; lng; " bytes"
3456     ELSE
3458         PRINT# ch%, "Font NOT FOUND"
3460         RETurn
3462     END IF
3464     base = ALCHP(lng)
3466     LBYTES file$, base
3468 :
3470     IF type% = 1 THEN type% = TestFount%(base)
3472     IF type% = 1 THEN type$ = "(5x9)" : ELSE type$ = "(8x9)"
3474     AT# ch%, 0, 7 + LEN(file$)
3476     PRINT #ch%, type$;
3478 :
3480     AT# ch%, 1, 0
3482     REMark ''LONGLINE
3484     PRINT# ch%, "Lowest character code = "; PEEK(base); "        ";
3486     AT# ch%, 1, 44
3488     PRINT# ch%, "Number of characters  = "; PEEK(base+1) + 1
3490     PRINT# ch%,"  "
3492     CHAR_USE# ch%, base, 0
3494     CSIZE# ch%, (type% = 2), 0
3496     CHAR_INC# ch%, 6 + 2 * (type% = 2), 10
3498     FOR i = 0 TO 9
3500         PRINT# ch%, CHR$(i);
3502         NEXT i
3504     END FOR i
3506     PRINT# ch%, " ";
3508     FOR i = 11 TO 255 : PRINT# ch%, CHR$(i); :NEXT i: END FOR i
3510     PRINT# ch%, CHR$(10)
3512     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3514     CSIZE# ch%, 2 + (type% = 2), 0
3516     CHAR_INC# ch%, 12 + 4 * (type% = 2), 10
3518     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3520     CSIZE# ch%, 2 + (type% = 2), 1
3522     CHAR_INC# ch%, 12 + 4 * (type% = 2), 20
3524     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
3526     CHAR_USE# ch%, 0, 0
3528     RECHP base
3530     xx$ = INKEY$(-1)
3532 END DEFine
3534 :
3536 :
3538 REMark ''----------------------------------------------------------
3540 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
3542     LOCal ch%, k$, AtX%,AtY%
3544 :
3546     AtX% = (maxWinWid% - width%) DIV 2
3548     AtY% = (256 - height%) DIV 2
3550     ch% = FOPEN("con")
3552     OUTLN# ch%; width% - 2, height%, AtX%, AtY%, 4, 3
3554 :
3556     SELect ON type%
3558       = 1:
3560           PAPER# ch%, Green%
3562           INK# ch%, 0
3564           CLS# ch%
3566           BLOCK# ch%, width% - 4, 8, 1, 1, Green%, 1, 1
3568           AT# ch%, 1, 1
3570           PRINT# ch%, text$
3572 :
3574       = 2:
3576           PAPER# ch%, 2
3578           INK# ch%, White%
3580           CLS# ch%
3582           BLOCK# ch%, width% - 4, 8, 1, 1, 2, 1, 1
3584           CURSOR# ch%, (width% - 49) DIV 2, 1
3586           PRINT# ch%, " ERROR "
3588           AT# ch%, 1, 1
3590           PRINT# ch%, text$
3592 :
3594       = 3:
3596           PAPER# ch%, White%
3598           INK# ch%, 0
3600           BORDER# ch%, 1, 2
3602           CLS# ch%
3604           BLOCK# ch%, width% - 8, 8, 1, 1, 2 ,0 , 1
3606           CURSOR# ch%, (width% - 49) DIV 2, 1
3608           PRINT# ch%, " ABOUT "
3610           CURSOR#ch%, 2, 15
3612           PRINT# ch%, text$
3614 :
3616     END SELect
3618 :
3620     CURSOR# ch%, (width% - 130) DIV 2, 48
3622     PRINT# ch%, "... press any key ..."
3624     k$ = INKEY$(-1)
3626     OUTLN# ch%; width%, height%, AtX%, AtY%
3628     CLOSE# ch%
3630 END DEFine
3632 :
3634 :
3636 REMark ''----------------------------------------------------------
3638 REMark ''_ used as placeholder, CAN be used ith () parentheses !!!
3640 DEFine FuNction IsDir%(_)
3642     LOCal k%
3644 :
3646     IF crtPanel% = 7
3648         k% = GetFFlg%(LeftFiles$, LIndex%) MOD 2
3650     ELSE
3652         k% = GetFFlg%(RightFiles$, RIndex%) MOD 2
3654     END IF
3656     RETurn k%
3658 END DEFine
3660 :
3662 :
3664 REMark ''----------------------------------------------------------
3666 DEFine PROCedure ViewImage(a$, m%)
3668     LOCal ch%, ch1%, scrSz, scrBuf, maxScrSz
3670 :
3672     IF maxWinHgt% > 256 OR maxWinWid% > 512 OR RMODE > 8
3674         REMark ''LONGLINE
3676         MessageWnd 200, 60, 2, CHR$(10) & " _scr images can only be viewed" & CHR$(10) & "  on classic QL configuration"
3678         RETurn
3680     END IF
3682     maxScrSz = 32768
3684     REMark ''use _+ as #, __+ as \ ???
3686     scrSz = FLEN(\a$)
3688     IF scrSz > maxScrSz
3690         scrBuf = ALCHP(scrSz)
3692         IF scrBuf < 0 THEN BEEP 1390,10 : RETurn
3694         LBYTES a$, scrBuf
3696         a$ = TempDir$ & "tmp_scr"
3698         SBYTES_O a$, scrBuf, maxScrSz
3700         RECHP scrBuf
3702     END IF
3704     ch% = FOPEN("con")
3706     OUTLN# ch%; 512, 256, 0, 0
3708     IF m% = 4 THEN MODE 4 : ELSE MODE 8
3710     LBYTES a$, 131072
3712     PAUSE 10
3714     k% = CODE(INKEY$(-1))
3716 :
3718     SELect ON k%
3720       = 52:
3722         OUTLN# ch%; 512, 256, 0, 0
3724         CLOSE# ch%
3726         ViewImage a$, 4
3728 :
3730       = 56:
3732         OUTLN# ch%; 512, 256, 0, 0
3734         CLOSE# ch%
3736         ViewImage a$, 8
3738 :
3740       = REMAINDER :
3742         MODE 4
3744         OUTLN# ch%; 512, 256, 0, 0
3746         CLOSE# ch%
3748         DELETE TempDir$ & "tmp_scr"
3750 :
3752     END SELect
3754 :
3756 END DEFine
3758 :
3760 :
3762 REMark ''----------------------------------------------------------
3764 DEFine FuNction InputWnd$(width%, height%, title$, text$, start$)
3766     LOCal ch%, ch1%, k$, AtX%,AtY%
3768 :
3770     AtX% = (maxWinWid% - width%) DIV 2
3772     AtY% = (256 - height%) DIV 2
3774     ch% = FOPEN("con")
3776     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
3778     BORDER# ch%, 1, 4
3780     PAPER# ch%, White%
3782     INK# ch%, 0
3784     CLS# ch%
3786     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
3788     PAPER# ch%, Green%
3790     INK# ch%, 0
3792     CURSOR# ch%,(width% - 6 - LEN(title$) * 6) DIV 2, 0
3794     PRINT# ch%, title$
3796     PAPER# ch%, White%
3798     INK# ch%, 0
3800     CURSOR# ch%, 6, 16
3802     PRINT# ch%, text$
3804     CURSOR# ch%, (width% - 198) DIV 2, 48
3806     PRINT# ch%, "... leave it empty to cancel ..."
3808     ch1% = FOPEN("con")
3810     WINDOW# ch1%, width% - 18, 12, AtX% + 8, AtY% + 28
3812     PAPER# ch1%, 0
3814     INK# ch1%, White%
3816     CLS# ch1%
3818     REMark ''use _+ as #, __+ as \ ???
3820     k$ = EDIT$(#ch1%, start$, 36)
3822     CLOSE# ch1%
3824     OUTLN# ch%; width%, height%, AtX%, AtY%
3826     CLOSE# ch%
3828     RETurn k$
3830 END DEFine
3832 :
3834 :
3836 REMark ''----------------------------------------------------------
3838 DEFine FuNction DirExists%(name$)
3840     LOCal er%, ch%, d$, dname$
3842 :
3844     dbg name$
3846     dname$ = name$
3848     IF dname$(LEN(dname$)) <> "_"
3850         dname$ = dname$ & "_"
3852     END IF
3854     IF LEN(dname$) = 5
3856         d$ = DATAD$
3858         DATA_USE CHR$(0)
3860         ch% = FOP_DIR(dname$)
3862         DATA_USE d$
3864         IF ch% < 0
3866             er% = 0
3868         ELSE
3870             CLOSE# ch%
3872             er% = 1
3874         END IF
3876     ELSE
3878         IF FTEST(dname$) = 0
3880             REMark ''use _+ as #, __+ as \ ???
3882             IF FTYP(\dname$) = 255
3884                 er% = 1
3886             ELSE
3888                 er% = 0
3890             END IF
3892         ELSE
3894             er% = 0
3896         END IF
3898     END IF
3900     RETurn er%
3902 END DEFine
3904 :
3906 :
3908 REMark ''----------------------------------------------------------
3910 DEFine PROCedure CreateDir
3912     LOCal x%, DirName$, FullDirName$
3914 :
3916     REMark ''LONGLINE
3918     DirName$ = InputWnd$(240, 60, " Create Directory ", "Directory Name:", "")
3920     DirName$ = UPPER$(DirName$)
3922     IF DirName$ = "" THEN RETurn
3924     IF crtPanel% = 7
3926         FullDirName$ = leftDir$ & DirName$
3928     ELSE
3930         FullDirName$ = rightDir$ & DirName$
3932     END IF
3934     x% = Create1Dir%(DirName$, FullDirName$, crtPanel%, 1, 1, 1)
3936 END DEFine
3938 :
3940 :
3942 REMark ''----------------------------------------------------------
3944 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
3946     LOCal res%, fres%, page%, msg$
3948 :
3950     IF LEN(FullDirName$) > 41
3952         IF UpdateWnd% = 1
3954             REMark ''LONGLINE
3956             MessageWnd 200, 60, 2, CHR$(10) & "          Name too long !"
3958             RETurn 0
3960         ELSE
3962           INK# 0, 2
3964           PRINT# 0, "Directory not created  Name too long"
3966           INK# 0, White%
3968           RETurn 0
3970         END IF
3972     END IF
3974     IF (Qubide% = 1) AND (CheckNoQ% = 1)
3976         IF TestQubideRestriction%(DirName$, panel%) = 1
3978             IF UpdateWnd% = 1
3980                 REMark ''LONGLINE
3982                 MessageWnd 200, 60, 2, "   Cannot create Directory !" & CHR$(10) & "  QUBIDE limitation: Files will" & CHR$(10) & "     fall in the directory !"
3984                 RETurn 0
3986             ELSE
3988                 INK# 0, 2
3990                 REMark ''LONGLINE
3992                 PRINT# 0, "Directory not created QUBIDE limitation: Files will fall in the directory"
3994                 INK# 0, White%
3996                 RETurn 0
3998             END IF
4000         END IF
4002     END IF
4004     IF DirName$(LEN(DirName$)) = "_"
4006         DirName$ = DirName$(1 TO LEN(DirName$) - 1)
4008     END IF
4010     IF panel% = 7
4012         REMark ''LONGLINE
4014         IF (CheckNoQ% = 1) AND (LSizedir% + LSizeFile% + 1 >= MaxFiles%)
4016             IF UpdateWnd% = 1
4018                 REMark ''LONGLINE
4020                 MessageWnd 200,60,2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
4022                 RETurn 0
4024             ELSE
4026                 INK# 0, 2
4028                 REMark ''LONGLINE
4030                 PRINT# 0,"Directory not created. You have reached the maximum number of files and directories"
4032                 INK# 0, White%
4034                 RETurn -1
4036             END IF
4038         ELSE
4040             fres% = FMAKE_DIR(FullDirName$)
4042             IF (UpdateList% = 1) AND (fres% >= 0)
4044                 REMark ''LONGLINE
4046                 res% = Find%(DirName$, id%, LeftFiles$, 1, LSizedir%)
4048                 IF res% = 0
4050                     REMark ''LONGLINE
4052                     res% = Insert%(DirName$, id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
4054                 END IF
4056                 LIndex% = id%
4058                 IF UpdateWnd% = 1
4060                     id% = id% + (LMinPos% = 0)
4062                     page% = id% DIV rowno%
4064                     REMark ''LONGLINE
4066                     IF id% MOD rowno% > 0 THEN page% = page% + 1
4068                     LStartPos% = (page% - 1) * rowno% + LMinPos%
4070                     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4072                 END IF
4074                 RETurn 1
4076             ELSE
4078                 IF fres% >= 0 THEN RETurn 1
4080             END IF
4082         END IF
4084     ELSE
4086         REMark ''LONGLINE
4088         IF (CheckNoQ% = 1) AND (RSizedir% + RSizeFile% + 1 >= MaxFiles%)
4090             IF UpdateWnd% = 1
4092                 REMark ''LONGLINE
4094                 MessageWnd 200, 60, 2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
4096                 RETurn 0
4098             ELSE
4100                 INK# 0, 2
4102                 REMark ''LONGLINE
4104                 PRINT# 0, "Directory not created. You have reached the maximum number of files and directories"
4106                 INK# 0, White%
4108                 RETurn -1
4110             END IF
4112         ELSE
4114             fres% = FMAKE_DIR(FullDirName$)
4116             IF (UpdateList% = 1) AND (fres% >= 0)
4118                 REMark ''LONGLINE
4120                 res% = Find%(DirName$, id%, RightFiles$, 1, RSizedir%)
4122                 IF res% = 0
4124                     REMark ''LONGLINE
4126                     res% = Insert%(DirName$, id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
4128                 END IF
4130                 RIndex% = id%
4132                 IF UpdateWnd% = 1
4134                     id% = id% + (RMinPos% = 0)
4136                     page% = id% DIV rowno%
4138                     REMark ''LONGLINE
4140                     IF id% MOD rowno% > 0 THEN page% = page% + 1
4142                     RStartPos% = (page% - 1) * rowno% + RMinPos%
4144                     ListFiles RightFiles$, RStartPos%, RIndex%, 8
4146                 END IF
4148                 RETurn 1
4150             ELSE
4152                 IF fres% >= 0 THEN RETurn 1
4154             END IF
4156         END IF
4158     END IF
4160 :
4162     SELect ON fres%
4164       = -8, -9:
4166         REMark ''LONGLINE
4168         msg$ = "   Cannot create Directory !" & CHR$(10) & "    A file or a directory with" & CHR$(10) & "    same name already exists !"
4170 :
4172       = -11:
4174         REMark ''LONGLINE
4176         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Drive full"
4178 :
4180       = -15:
4182         REMark ''LONGLINE
4184         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Drive is not Level2"
4186 :
4188       = -19:
4190         REMark ''LONGLINE
4192         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Not implemented yet"
4194 :
4196       = -20:
4198         REMark ''LONGLINE
4200         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "        Drive is Read Only "
4202 :
4204       = REMAINDER :
4206         REMark ''LONGLINE
4208         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Error " & fres%
4210 :
4212     END SELect
4214 :
4216     IF UpdateWnd% = 1
4218         MessageWnd 200, 60, 2, msg$
4220         IF (fres% = -15) OR (fres% = -19)
4222             DELETE FullDirName$
4224         END IF
4226         RETurn 0
4228     ELSE
4230         SELect ON fres%
4232           = -8, -9:
4234             INK# 0,2
4236             REMark ''LONGLINE
4238             PRINT# 0, "Directory not created  A file or a directory with same name already exists"
4240             INK# 0, White%
4242             RETurn 0
4244 :
4246           REMark ''= -9:
4248           REMark ''  ink# 0, 2
4250           REMark ''  print# 0, "Directory not created  A directory with same name already exists"
4252           REMark ''  ink# 0, White%
4254           REMark ''  Return 0
4256 :
4258           = -11:
4260             INK# 0,2
4262             PRINT# 0, "Directory not created Drive full"
4264             INK# 0, White%
4266             RETurn -1
4268 :
4270           = -15:
4272             INK# 0, 2
4274             REMark ''LONGLINE
4276             PRINT# 0, "Directory not created  Drive is not Level2"
4278             INK# 0, White%
4280             RETurn -1
4282 :
4284           = -19:
4286             INK# 0, 2
4288             REMark ''LONGLINE
4290             PRINT# 0, "Directory not created  Operation not implemented yet for this drive type"
4292             INK# 0, White%
4294             RETurn -1
4296 :
4298           = -20:
4300             INK# 0, 2
4302             REMark ''LONGLINE
4304             PRINT# 0, "Directory not created  Drive is Read Only "
4306             INK# 0, White%
4308             RETurn -1
4310 :
4312           = REMAINDER :
4314             INK# 0, 2
4316             PRINT# 0, "Directory not created  Error " & fres%
4318             INK# 0, White%
4320             RETurn 0
4322         END SELect
4324     END IF
4326 :
4328 END DEFine
4330 :
4332 :
4334 REMark ''-----------------------------------------------------------
4336 REMark ''_ as placeholder, CAN be used with () parentheses !!!
4338 DEFine FuNction CountSelected%(_)
4340     LOCal i%, counter%
4342 :
4344     counter% = 0
4346 :
4348     IF crtPanel% = 7
4350         FOR i% = 1 TO LSizedir% + LSizeFile%
4352             IF GetFFlg%(LeftFiles$, i%) > 1
4354                 counter% = counter% + 1
4356             END IF
4358         END FOR i%
4360     ELSE
4362         FOR i% = 1 TO RSizedir% + RSizeFile%
4364             IF GetFFlg%(RightFiles$,i%) > 1
4366                 counter% = counter% + 1
4368             END IF
4370         END FOR i%
4372     END IF
4374     RETurn counter%
4376 END DEFine
4378 :
4380 :
4382 REMark ''---------------------------------------------------------
4384 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
4386     LOCal ch%, a$, k%, AtX%, AtY%, loopa
4388 :
4390     AtX% = (maxWinWid% - width%) DIV 2
4392     AtY% = (256 - height%) DIV 2
4394     ch% = FOPEN("con")
4396     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
4398     BORDER# ch%, 1, Green%
4400     PAPER# ch%, White%
4402     INK# ch%, 0
4404     CLS# ch%
4406     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
4408     PAPER# ch%, Green%
4410     INK# ch%, 0
4412     CURSOR# ch%, (width% - 6 - LEN(title$) * 6) DIV 2, 0
4414     PRINT# ch%, title$
4416     PAPER# ch%, White%
4418     INK# ch%, 0
4420     CURSOR# ch%, 6, 16
4422     PRINT# ch%, text$
4424     CURSOR# ch%, (width% - 198) DIV 2, 48:
4426     INK# ch%, 2
4428     PRINT# ch%, "    C";
4430     INK# ch%, 0
4432     PRINT# ch%, "ancel                ";
4434     INK# ch%, 2
4436     PRINT# ch%, "O";
4438     INK# ch%, 0
4440     PRINT# ch%, "k"
4442     REPeat loopa
4444        a$ = INKEY$(-1)
4446        REMark ''LONGLINE
4448        IF a$ INSTR "oO" & CHR$(10) THEN k% = 1: EXIT loopa
4450        REMark ''LONGLINE
4452        IF a$ INSTR "cC" & CHR$(27) THEN k% = 0: EXIT loopa
4454     END REPeat loopa
4456     OUTLN# ch%; width%, height%, AtX%, AtY%
4458     CLOSE# ch%
4460     RETurn k%
4462 END DEFine
4464 :
4466 :
4468 REMark ''----------------------------------------------------------
4470 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
4472     LOCal i%, name$
4474 :
4476     name$ = DirName$
4478     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
4480     IF panel% = 7
4482         FOR i% = LSizedir% + 1 TO LSizedir% + LSizeFile%
4484             REMark ''LONGLINE
4486             IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1
4488         END FOR i%
4490     ELSE
4492         FOR i% = RSizedir% + 1 TO RSizedir% + RSizeFile%
4494             REMark ''LONGLINE
4496             IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1
4498         END FOR i%
4500     END IF
4502     RETurn 0
4504 END DEFine
4506 :
4508 :
4510 REMark ''----------------------------------------------------------
4512 DEFine FuNction IsQuillDoc%(a$)
4514     LOCal ch%, q$, i%, k%
4516 :
4518     ch% = FOPEN(a$)
4520     IF ch% <= 0 THEN RETurn 0
4522     q$ = ""
4524     BGET# ch%\1, k%
4526     FOR i% = 1 TO 8
4528         BGET# ch%, k%
4530         q$ = q$ & CHR$(k%)
4532         NEXT i%
4534     END FOR i%
4536     CLOSE# ch%
4538     IF q$ = "vrm1qdf0" THEN RETurn 1 : ELSE RETurn 0
4540 END DEFine
4542 :
4544 :
4546 REMark ''-----------------------------------------------------------
4548 DEFine FuNction IsZipFile%(a$)
4550     LOCal ch%, q$, i%, k%
4552 :
4554     ch% = FOPEN(a$)
4556     IF ch% <= 0 THEN RETurn 0
4558     q$ = ""
4560     FOR i% = 1 TO 4
4562         BGET# ch%, k%
4564         q$ = q$ & CHR$(k%)
4566         NEXT i%
4568     END FOR i%
4570     CLOSE# ch%
4572     IF q$ = "PK" & CHR$(3) & CHR$(4)
4574         RETurn 1
4576     ELSE
4578         RETurn 0
4580     END IF
4582 END DEFine
4584 :
4586 :
4588 REMark ''----------------------------------------------------------
4590 DEFine PROCedure RenameFile
4592     LOCal NewFileName$, filename$, sourcepath$
4594     LOCal res%, i%, x%, filelen$, page%
4596 :
4598     IF crtPanel% = 7
4600         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
4602     ELSE
4604         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
4606     END IF
4608     IF crtPanel% = 7
4610         filename$ = GetFNam$(LeftFiles$, LIndex%)
4612         sourcepath$ = leftDir$
4614     ELSE
4616        filename$ = GetFNam$(RightFiles$, RIndex%)
4618        sourcepath$ = rightDir$
4620     END IF
4622     IF filename$ = ".." THEN RETurn
4624     IF IsDir%() = 1
4626         REMark ''LONGLINE
4628         MessageWnd 200, 60, 2, CHR$(10) & "   Cannot rename a Directory!"
4630         RETurn
4632     END IF
4634     res% = FTEST(sourcepath$ & filename$)
4636     IF res% = -9
4638         REMark ''LONGLINE
4640         MessageWnd 200, 60, 2, CHR$(10) & "   File in Use! Cannot rename!"
4642         RETurn
4644     END IF
4646     IF res% = -20
4648         REMark ''LONGLINE
4650         MessageWnd 200, 60, 2, CHR$(10) & "       File is Read Only! " & CHR$(10) & "          Cannot rename!"
4652         RETurn
4654     END IF
4656     REMark ''LONGLINE
4658     NewFileName$ = InputWnd$(240, 60, " Rename File ", "Rename " & filename$ & " to:", filename$)
4660     IF NewFileName$ = "" THEN RETurn
4662     IF LEN(sourcepath$ & NewFileName$) > 36
4664         REMark ''LONGLINE
4666         MessageWnd 200, 60, 2, CHR$(10) & "   Full file name is too long!"
4668         RETurn
4670     END IF
4672     IF FTEST(sourcepath$ & NewFileName$) <> -7
4674         REMark ''LONGLINE
4676         MessageWnd 200, 60, 2, CHR$(10) & "      A file with this name" & CHR$(10) & "          already exists!"
4678         RETurn
4680     END IF
4682     RENAME sourcepath$ & filename$ TO sourcepath$ & NewFileName$
4684     IF crtPanel% = 7
4686         filelen$ = GetFLen(LeftFiles$, LIndex%)
4688         REMark ''LONGLINE
4690         ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
4692         FOR i% = LIndex% + 1 TO LSizedir% + LSizeFile%
4694             CopyRec LeftFiles$, i% TO LeftFiles$, i% - 1
4696         END FOR i%
4698         LSizeFile% = LSizeFile% - 1
4700         REMark ''LONGLINE
4702         x% = Find%(NewFileName$, id%, LeftFiles$, LSizedir% + 1, LSizedir% + LSizeFile%)
4704         REMark ''LONGLINE
4706         x% = Insert%(NewFileName$, id%, LeftFiles$, 0, LSizedir%, LSizeFile%, filelen$)
4708         LIndex% = id%
4710         x% = id% + (LMinPos% = 0)
4712         page% = x% DIV rowno%
4714         IF x% MOD rowno% > 0 THEN page% = page% + 1
4716         LStartPos% = (page% - 1) * rowno% + LMinPos%
4718         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4720     ELSE
4722         filelen$ = GetFLen(RightFiles$, RIndex%)
4724         REMark ''LONGLINE
4726         ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
4728         FOR i% = RIndex% + 1 TO RSizedir% + RSizeFile%
4730             CopyRec RightFiles$, i% TO RightFiles$, i% - 1
4732         END FOR i%
4734         RSizeFile% = RSizeFile% - 1
4736         REMark ''LONGLINE
4738         x% = Find%(NewFileName$, id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
4740         REMark ''LONGLINE
4742         x% = Insert%(NewFileName$, id%, RightFiles$, 0, RSizedir%, RSizeFile%, filelen$)
4744         RIndex% = id%
4746         x% = id% + (RMinPos% = 0)
4748         page% = x% DIV rowno%
4750         IF x% MOD rowno% > 0 THEN page% = page% + 1
4752         RStartPos% = (page% - 1) * rowno% + RMinPos%
4754         ListFiles RightFiles$, RStartPos%, RIndex%, 8
4756     END IF
4758 END DEFine
4760 :
4762 :
4764 :
4766 REMark ''-----------------------------------------------------------
4768 DEFine PROCedure ShowInfo
4770    LOCal filename$(36), path$(36), chf%, ch%, ch1%, ch2%
4772    LOCal x%, k$(2), windef$, left%, top%
4774 :
4776     IF crtPanel% = 7
4778         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
4780     ELSE
4782         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
4784     END IF
4786 :
4788     IF crtPanel% = 7
4790         filename$ = GetFNam$(LeftFiles$, LIndex%)
4792         path$ = leftDir$
4794     ELSE
4796         filename$ = GetFNam$(RightFiles$, RIndex%)
4798         path$ = rightDir$
4800     END IF
4802 :
4804     IF filename$ = ".." THEN RETurn
4806     left% = (maxWinWid% - 452) DIV 2
4808     IF maxWinHgt% > 256 THEN top% = 51: ELSE top% = 14
4810     windef$ = "scr_452x230a" & left% & "x" & top%
4812     ch% = FOPEN(windef$)
4814     PAPER# ch%, 0
4816     INK# ch%, White%
4818     OUTLN# ch%, 452, 230, left%, top%
4820     BORDER# ch%, 1, 2
4822     CLS# ch%
4824     windef$ = "scr_452x12a" & left% & "x" & top%
4826     ch1% = FOPEN(windef$)
4828     BORDER# ch1%, 1, 2
4830     PAPER# ch1%, 0, 2, 1
4832     CLS# ch1%
4834     PAPER# ch1%, 0
4836     INK# ch1%, White%
4838     AT# ch1%, 0, 34
4840     PRINT# ch1%, " Info "
4842     windef$ = "scr_448x204a" & (left% + 2) & "x" & (top% + 12)
4844     ch2% = FOPEN(windef$)
4846     PAPER# ch2%, 0
4848     INK# ch2%, Green%
4850     PRINT# ch2%, "Full name: "; path$ & filename$; CHR$(10);
4852 :
4854     chf% = FOPEN(path$ & filename$)
4856     IF chf% < 0
4858         INK# ch2%, 2
4860         SELect ON chf%
4862           = -7:
4864             PRINT# ch2%, "File Not Found !"
4866 :
4868           = -9:
4870             PRINT# ch2%, "File in use"
4872 :
4874           = REMAINDER :
4876             PRINT# ch2%, "Error "; chf%
4878 :
4880         END SELect
4882         REMark ''FIXME mixworx channel # ??? default ???
4884         INK 4
4886     ELSE
4888         GetHEAD# chf%, headBuff
4890         PRINT# ch2%, "File Length:";
4892         REMark ''LONGLINE
4894         PRINT_USING# ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
4896         x% = PEEK(headBuff + 5)
4898         PRINT# ch2%, "File Type:   "; x%; " - ";
4900 :
4902         SELect ON x%
4904           =  0:
4906             REMark ''LONGLINE
4908             PRINT# ch2%, "BASIC, CALLable machine code, extensions or DATA file"
4910 :
4912           =  1:
4914             PRINT# ch2%, "EXECable file"
4916 :
4918           =  2:
4920             REMark ''LONGLINE
4922             PRINT# ch2%, "SROFF file used by linkers etc, a C68 Library file etc"
4924 :
4926           =  3:
4928             REMark ''LONGLINE
4930             PRINT# ch2%, "THOR hard disc directory file. (I think!)"
4932 :
4934           =  4:
4936             PRINT# ch2%, "A font file for The Painter"
4938 :
4940           =  5:
4942             PRINT# ch2%, "A pattern file for The Painter"
4944 :
4946           =  6:
4948             REMark ''LONGLINE
4950             PRINT# ch2%, "A compressed mode 4 screen in The Painter"
4952 :
4954           = 11:
4956             REMark ''LONGLINE
4958             PRINT# ch2%, "A compressed mode 8 screen in The Painter"
4960 :
4962           =255:
4964             REMark ''LONGLINE
4966             PRINT# ch2%, "Level 2 driver directory or sub-directory file"
4968 :
4970           =REMAINDER :
4972             PRINT# ch2%, " "
4974         END SELect
4976 :
4978         PRINT# ch2%, "Data-space: ";
4980         IF x% = 1
4982             REMark ''LONGLINE
4984             PRINT_USING# ch2%, "##,###,###. bytes\", PEEK_L(headBuff + 6)
4986         ELSE
4988             PRINT# ch2%, "   n/a"
4990         END IF
4992         PRINT# ch2%, "File Version:  "; PEEK_W(headBuff + 56)
4994         PRINT# ch2%, "Last modified: ";
4996         d = PEEK_L(headBuff + 52)
4998         IF d
5000             PRINT# ch2%, DATE$(d)
5002         ELSE
5004             PRINT# ch2%, "<not-set>"
5006         END IF
5008         PRINT# ch2%, "Backup date:   ";
5010         d = PEEK_L(headBuff + 60)
5012         IF d
5014             PRINT# ch2%, DATE$(d)
5016         ELSE
5018             PRINT# ch2%, "<not-set>"
5020         END IF
5022         CLOSE# chf%
5024     END IF
5026 :
5028     REMark ''LONGLINE
5030     PRINT# ch2%, CHR$(10); "------------------------------------------------------------------------"; CHR$(10)
5032     PRINT# ch2%, "ROM Version:  "; VER$
5034     PRINT# ch2%, "QDOS Version: "; VER$(1)
5036     PRINT# ch2%, "Current RAMTOP: ";
5038     PRINT_USING# ch2%, "##,###.#", RESPR(0) DIV 1024 - 128
5040     PRINT# ch2%, " Kb"
5042     PRINT# ch2%, "Free memory:    ";
5044     PRINT_USING# ch2%, "##,###.#", FREE_MEM DIV 1024
5046     PRINT# ch2%, " Kb"
5048     PRINT# ch2%
5050     PRINT# ch2%, "DataD$: "; DATAD$
5052     PRINT# ch2%, "ProgD$: "; PROGD$
5054     PRINT# ch2%, "DestD$: "; DESTD$
5056 :
5058     k$ = INKEY$(-1)
5060     CLS# ch1%
5062     CLS# ch2%
5064     CLOSE# ch2%
5066     CLOSE# ch1%
5068     OUTLN# ch%, 452, 230, left%, top%
5070     CLOSE# ch%
5072 :
5074 END DEFine
5076 :
5078 :
5080 REMark ''----------------------------------------------------------
5082 DEFine PROCedure WriteCommands(ch%)
5084     LOCal lat, px%, px1%, i%, x%, lat%(9)
5086 :
5088     lat = (comWinWid% - 4) DIV 9
5090     rest = (comWinWid% - 4) MOD 9
5092     FOR i% = 1 TO 9 : lat%(i%) = lat : NEXT i%
5094     IF rest >= 0 THEN lat%(4) = lat + 1
5096     IF rest >= 1 THEN lat%(3) = lat + 1
5098     IF rest >= 2 THEN lat%(5) = lat + 1
5100     IF rest >= 3 THEN lat%(1) = lat + 1
5102     IF rest >= 4 THEN lat%(2) = lat + 1
5104     IF rest >= 5 THEN lat%(6) = lat + 1
5106     IF rest >= 6 THEN lat%(7) = lat + 1
5108     IF rest >= 7 THEN lat%(8) = lat + 1
5110     IF rest >= 8 THEN lat%(9) = lat + 1
5112     px% = 0
5114     PAPER# ch%, PPR9a%, ppr9b%, 3
5116 :
5118     FOR i% = 1 TO 9
5120         REMark ''LONGLINE
5122         BLOCK# ch%, lat%(i%) - 1, mainFountHeight%, px%, 0, PPR9a%, ppr9b%, 3
5124         REMark ''LONGLINE
5126         x% = px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
5128         CURSOR# ch%, x%, 0
5130         PRINT# ch%, cmdText$(i%);
5132         px% = px% + lat%(i%)
5134     END FOR i%
5136 :
5138 END DEFine
5140 :
5142 :
5144 REMark ''----------------------------------------------------------
5146 DEFine FuNction IsReadOnly%(a$)
5148   LOCal res%
5150 :
5152   res% = FOPEN(a$ & CHR$(0))
5154   IF res% = -20 THEN RETurn 1
5156   IF res% > 0 THEN DELETE a$ & CHR$(0)
5158   RETurn 0
5160 END DEFine
5162 :
5164 :
5166 REMark ''----------------------------------------------------------
5168 DEFine PROCedure CopyFiles
5170     LOCal k%, x%, name$, source$, dest$, filelen$, panel%
5172 :
5174     x% = CountSelected%()
5176     IF crtPanel% = 7
5178         source$ = leftDir$ : dest$ = rightDir$
5180         name$ = GetFNam$(LeftFiles$, LIndex%)
5182         filelen$ = GetFLen(LeftFiles$, LIndex%)
5184         panel% = 8
5186     ELSE
5188         dest$ = leftDir$ : source$ = rightDir$
5190         name$ = GetFNam$(RightFiles$, RIndex%)
5192         filelen$ = GetFLen(RightFiles$, RIndex%)
5194         panel% = 7
5196     END IF
5198 :
5200     IF IsReadOnly%(dest$)
5202         REMark ''LONGLINE
5204         MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!"
5206         RETurn
5208     END IF
5210 :
5212     IF x% > 0
5214         REMark ''LONGLINE
5216         k% = DlgWnd%(240, 60, " Copy Files ", "    Are you sure you want to copy" & CHR$(10) & "     " & x% & " files and directories ?")
5218         IF k% = 1 THEN CopyMultipleFiles x%
5220     ELSE
5222         IF IsDir%() = 1
5224             CopySingleDir name$, source$, dest$, panel%
5226         ELSE
5228             IF LEN(dest$&name$) > 41
5230                 REMark ''LONGLINE
5232                 MessageWnd 200, 60, 2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
5234                 RETurn
5236             END IF
5238             k% = FTEST(dest$ & name$)
5240             IF k% = -7
5242                 IF crtPanel% = 7
5244                     IF RSizedir% + RSizeFile% + 1 >= MaxFiles%
5246                         REMark ''LONGLINE
5248                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5250                         RETurn
5252                     END IF
5254                 ELSE
5256                     IF LSizedir% + LSizeFile% + 1 >= MaxFiles%
5258                         REMark ''LONGLINE
5260                         MessageWnd 200, 60, 2, CHR$(10) & "        Cannot copy file" & CHR$(10) & "      maximum number reached !"
5262                         RETurn
5264                     END IF
5266                 END IF
5268                 Copy1File name$, source$, dest$, filelen$, 1
5270                 RETurn
5272             ELSE
5274                 IF k% = 0
5276                     REMark ''LONGLINE
5278                     x% = DlgWnd%(240, 60, " Copy Files ", "   Destination file already exists" & CHR$(10) & "              Overwrite ?")
5280                     IF x% = 1
5282                         Copy1File name$, source$, dest$, filelen$, 1
5284                         RETurn
5286                     END IF
5288                 ELSE
5290                    SELect ON k%
5292                      =  -9:
5294                         REMark ''LONGLINE
5296                        MessageWnd 200, 60, 2, CHR$(10) & "      Destination is in use " & CHR$(10) & "           Cannot copy!" : RETurn
5298 :
5300                      = -11:
5302                         REMark ''LONGLINE
5304                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination drive is full" & CHR$(10) & "           Cannot copy!" : RETurn
5306 :
5308                      = -16:
5310                         REMark ''LONGLINE
5312                        MessageWnd 200, 60, 2, CHR$(10) & "      Bad or Changed Medium" & CHR$(10) & "           Cannot copy!" : RETurn
5314 :
5316                      = -20:
5318                         REMark ''LONGLINE
5320                        MessageWnd 200, 60, 2, CHR$(10) & "    Destination is Read Only! " & CHR$(10) & "           Cannot copy!" : RETurn
5322 :
5324                      = REMAINDER :
5326                         REMark ''LONGLINE
5328                        MessageWnd 200, 60, 2, CHR$(10) & "     Error copying file : " & k% : RETurn
5330                    END SELect
5332                 END IF
5334             END IF
5336         END IF
5338 :
5340         IF crtPanel% = 7
5342             id% = RIndex% + (RMinPos% = 0)
5344             page% = id% DIV rowno%
5346             IF id% MOD rowno% > 0 THEN page% = page% + 1
5348             RStartPos% = (page% - 1) * rowno% + RMinPos%
5350             ListFiles RightFiles$, RStartPos%, RIndex%, 8
5352         ELSE
5354             id% = LIndex% + (LMinPos% = 0)
5356             page% = id% DIV rowno%
5358             IF id% MOD rowno% > 0 THEN page% = page% + 1
5360             LStartPos% = (page% - 1) * rowno% + LMinPos%
5362             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5364         END IF
5366 :
5368     END IF
5370 END DEFine
5372 :
5374 :
5376 REMark ''-----------------------------------------------------------
5378 DEFine PROCedure Copy1File(name$, source$, dest$, filelen$, UpdateList%)
5380     LOCal x%, page%
5382 :
5384     COPY_O source$ & name$ TO dest$ & name$
5386     IF crtPanel% = 8
5388         REMark ''LONGLINE
5390         x% = Find%(name$, id%, LeftFiles$, LSizedir% + 1, LSizedir% + LSizeFile%)
5392         IF x% = 0
5394             REMark ''LONGLINE
5396             x% = Insert%(name$, id%, LeftFiles$, 0, LSizedir%, LSizeFile%, filelen$)
5398         ELSE
5400             PutFLen LeftFiles$, id%, filelen$
5402         END IF
5404         LIndex% = id%
5406         IF UpdateList% = 1
5408             id% = id% + (LMinPos% = 0)
5410             page% = id% DIV rowno%
5412             IF id% MOD rowno% > 0 THEN page% = page% + 1
5414             LStartPos% = (page% - 1) * rowno% + LMinPos%
5416             ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5418         END IF
5420     ELSE
5422         REMark ''LONGLINE
5424         x% = Find%(name$, id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
5426         IF x% = 0
5428             REMark ''LONGLINE
5430             x% = Insert%(name$, id%, RightFiles$, 0, RSizedir%, RSizeFile%, filelen$)
5432         ELSE
5434             PutFLen RightFiles$, id%, filelen$
5436         END IF
5438         RIndex% = id%
5440         IF UpdateList% = 1
5442             id% = id% + (RMinPos% = 0)
5444             page% = id% DIV rowno%
5446             IF id% MOD rowno% > 0 THEN page% = page% + 1
5448             RStartPos% = (page% - 1) * rowno% + RMinPos%
5450             ListFiles RightFiles$, RStartPos%, RIndex%, 8
5452         END IF
5454     END IF
5456 END DEFine
5458 :
5460 :
5462 REMark ''----------------------------------------------------------
5464 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
5466     LOCal ch%, ch1%
5468 :
5470     IF CreateWnd% = 1
5472         ch% = FOPEN("scr_400x156a56x50")
5474         PAPER# ch%, 0
5476         INK# ch%, 7
5478         OUTLN# ch%, 400, 156, 56, 50
5480         BORDER# ch%, 1, 2
5482         CLS# ch%
5484         ch1% = FOPEN("scr_398x12a57x51")
5486         BORDER# ch1%, 1, 2
5488         PAPER# ch1%, 0, 2, 1
5490         CLS# ch1%
5492         PAPER# ch1%, 0
5494         INK# ch1%, 7
5496         AT# ch1%, 0, 25
5498         PRINT# ch1%, " Copy Directory "
5500         WINDOW# 0, 396, 140, 58, 63
5502         PAPER# 0, 0
5504         INK# 0, White%
5506         CLS# 0
5508     END IF
5510 :
5512     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
5514     WCOPY source$ & name$ TO dest$ & name$
5516     IF CreateWnd% = 1
5518         INK# 0, Green%
5520         REMark ''LONGLINE
5522         PRINT# 0, "Copy process ended - press any key to close window"
5524         INK# 0, White%
5526         x% = KEYROW(0)
5528         a$ = INKEY$(-1)
5530         WINDOW# 0, 448, 12, 32, 231:
5532         CLOSE# ch1%
5534         OUTLN# ch%, 400, 156, 56, 50
5536         CLOSE# ch%
5538     END IF
5540 END DEFine
5542 :
5544 :
5546 REMark ''----------------------------------------------------------
5548 DEFine PROCedure CopyMultipleFiles(k%)
5550     LOCal ch%, ch1%, i%, x%, a$, Index%, panel%
5552     LOCal page%, id%, left%,windef$, hgt%, wid%
5554 :
5556     IF panelWinWid% * 2 > 602
5558         wid% = 600
5560     ELSE
5562         wid% = 400
5564     END IF
5566 :
5568     hgt% = panelWinHeight% * 8 DIV 10
5570     left% = (maxWinWid% - wid%) DIV 2
5572     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
5574     ch% = FOPEN(windef$)
5576     PAPER# ch%, 0
5578     INK# ch%, White%
5580     OUTLN# ch%, wid%, hgt%, left%, 50
5582     BORDER# ch%, 1, 2
5584     CLS# ch%
5586     left% = left% + 1
5588     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
5590     ch1% = FOPEN(windef$)
5592     BORDER# ch1%, 1, 2
5594     PAPER# ch1%, 0, 2, 1
5596     CLS# ch1%
5598     PAPER# ch1%, 0
5600     INK# ch1%, White%
5602     CURSOR# ch1%, (wid% - 90) DIV 2, 0
5604     PRINT# ch1%, " Copy Selected "
5606     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
5608     PAPER# 0, 0
5610     INK# 0, White%
5612     CLS# 0
5614     REMark ''LONGLINE
5616     PRINT# 0, "Copy Selected list: " & k% & " files and/or directories"
5618 :
5620     IF crtPanel% = 7
5622         source$ = leftDir$
5624         dest$ = rightDir$
5626         Index% = LIndex%
5628         panel% = 8
5630         FOR i% = 1 TO LSizedir% + LSizeFile%
5632             LIndex% = i%
5634             IF GetFFlg%(LeftFiles$, i%) > 1
5636                 IF GetFFlg%(LeftFiles$, i%) = 2
5638                     REMark ''LONGLINE
5640                     PRINT# 0, "Copying file " & GetFNam$(LeftFiles$, i%) & " ..."
5642                     REMark ''LONGLINE
5644                     x% = CopyAListFile%(GetFNam$(LeftFiles$, i%), source$, dest$, GetFLen(LeftFiles$, i%), 8)
5646                 ELSE
5648                     REMark ''LONGLINE
5650                     PRINT# 0, "Copying directory " & GetFNam$(LeftFiles$, i%) & " ..."
5652                     REMark ''LONGLINE
5654                     x% = CopyFullDir%(GetFNam$(LeftFiles$, i%), source$, dest$, 8, 0, 1, 1)
5656                 END IF
5658                 IF x% = -1 THEN EXIT i%
5660                 REMark ''LONGLINE
5662                 PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
5664             END IF
5666             NEXT i%
5668         END FOR i%
5670         LIndex% = Index%
5672     ELSE
5674         source$ = rightDir$
5676         dest$ = leftDir$
5678         Index% = RIndex%
5680         FOR i% = 1 TO RSizedir% + RSizeFile%
5682             RIndex% = i%
5684             IF GetFFlg%(RightFiles$, i%) > 1
5686                 IF GetFFlg%(RightFiles$,i%) = 2
5688                     REMark ''LONGLINE
5690                     PRINT# 0, "Copying file " & GetFNam$(RightFiles$, i%) & " ..."
5692                     REMark ''LONGLINE
5694                     x% = CopyAListFile%(GetFNam$(RightFiles$, i%), source$, dest$, GetFLen(RightFiles$, i%), 7)
5696                 ELSE
5698                     REMark ''LONGLINE
5700                     PRINT# 0, "Copying directory " & GetFNam$(RightFiles$, i%) & " ..."
5702                     REMark ''LONGLINE
5704                     x% = CopyFullDir%(GetFNam$(RightFiles$, i%), source$, dest$, 7, 0, 1, 1)
5706                 END IF
5708                 IF x% = -1 THEN EXIT i%
5710                 REMark ''LONGLINE
5712                 PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
5714             END IF
5716             NEXT i%
5718         END FOR i%
5720         RIndex% = Index%
5722     END IF
5724 :
5726     INK# 0, Green%
5728     REMark ''LONGLINE
5730     PRINT# 0, "Copy process ended - press any key to close window"
5732     INK# 0, White%
5734     x% = KEYROW(0)
5736     a$ = INKEY$(-1)
5738     WINDOW# 0, 448, 12, 32, 231
5740     CLOSE# ch1%
5742     OUTLN# ch%, wid%, hgt%, left% - 1, 50
5744     CLOSE# ch%
5746     id% = RIndex% + (RMinPos% = 0)
5748     page% = id% DIV rowno%
5750     IF id% MOD rowno% > 0 THEN page% = page% + 1
5752     RStartPos% = (page% - 1) * rowno% + RMinPos%
5754     ListFiles RightFiles$, RStartPos%, RIndex%, 8
5756     id% = LIndex% + (LMinPos% = 0)
5758     page% = id% DIV rowno%
5760     IF id% MOD rowno% > 0 THEN page% = page% + 1
5762     LStartPos% = (page% - 1) * rowno% + LMinPos%
5764     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5766 END DEFine
5768 :
5770 :
5772 REMark ''----------------------------------------------------------
5774 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
5776     LOCal k%
5778 :
5780     IF LEN(dest$ & name$) > 41
5782         INK# 0, 2
5784         PRINT# 0, name$ & " not copied. Name too long"
5786         INK# 0, White%
5788         RETurn 0
5790     END IF
5792 :
5794     k% = FTEST(dest$ & name$)
5796 :
5798     IF k% = -7
5800         IF panel% = 8
5802             IF RSizedir% + RSizeFile% + 1 >= MaxFiles%
5804                 INK# 0, 2
5806                 REMark ''LONGLINE
5808                 PRINT# 0, "Maximum number reached on destination directory!"
5810                 INK# 0, White%
5812                 RETurn -1
5814             END IF
5816         ELSE
5818             IF LSizedir% + LSizeFile% + 1 >= MaxFiles%
5820                 INK# 0, 2
5822                 REMark ''LONGLINE
5824                 PRINT# 0, "Maximum number reached on destination directory!"
5826                 INK# 0, White%
5828                 RETurn -1
5830             END IF
5832         END IF
5834         Copy1File name$, source$, dest$, filelen$, 0
5836         RETurn 1
5838     ELSE
5840         IF k% = 0
5842             PRINT# 0, "File already exists Overwrite (Y/N) ?"
5844             REPeat loopa
5846                 a$ = INKEY$(-1)
5848                 IF a$ INSTR "yYnN" THEN EXIT loopa
5850             END REPeat loopa
5852             IF a$ = "y" OR a$ = "Y"
5854                 Copy1File name$, source$, dest$, filelen$, 0
5856                 RETurn 1
5858             ELSE
5860                 RETurn 0
5862             END IF
5864         ELSE
5866             SELect ON k%
5868               =  -9:
5870                 INK# 0, 2
5872                 REMark ''LONGLINE
5874                 PRINT# 0, name$ & "not copied. Destination is in use"
5876                 INK# 0, White%
5878                 RETurn 0
5880 :
5882               = -11:
5884                 INK# 0, 2
5886                 REMark ''LONGLINE
5888                 PRINT# 0, name$ & "not copied. Destination drive is full"
5890                 INK# 0, White%
5892                 RETurn -1
5894 :
5896               = -16:
5898                 INK# 0, 2
5900                 REMark ''LONGLINE
5902                 PRINT# 0, name$ & "not copied. Destination Bad or Changed Medium"
5904                 INK# 0, White%
5906                 RETurn -1
5908 :
5910               = -20:
5912                 INK# 0, 2
5914                 REMark ''LONGLINE
5916                 PRINT# 0, name$ & "not copied. Destination is Read Only! "
5918                 INK# 0, White%
5920                 RETurn 0
5922 :
5924               = REMAINDER :
5926                 INK# 0, 2
5928                 PRINT# 0, name$ & "not copied. Error " & k%
5930                 INK# 0, White%
5932                 RETurn 0
5934 :
5936             END SELect
5938         END IF
5940     END IF
5942 END DEFine
5944 :
5946 :
5948 REMark ''-----------------------------------------------------------
5950 DEFine PROCedure DeleteFiles
5952     LOCal source$, name$, panel%, x%, k%, a$, ch%, ch1%
5954     LOCal Index%, left%, windef$, hgt%, wid%
5956 :
5958     IF crtPanel% = 7
5960         source$ = leftDir$
5962         name$ = GetFNam$(LeftFiles$, LIndex%)
5964         panel% = 7
5966         Index% = LIndex%
5968     ELSE
5970         source$ = rightDir$
5972         name$ = GetFNam$(RightFiles$, RIndex%)
5974         panel% = 8
5976         Index% = RIndex%
5978     END IF
5980 :
5982     IF IsReadOnly%(source$)
5984         REMark ''LONGLINE
5986         MessageWnd 200, 60, 2, CHR$(10) & "       Drive is Read Only! "
5988         RETurn
5990     END IF
5992 :
5994     x% = CountSelected%()
5996 :
5998     IF x% > 0
6000         REMark ''LONGLINE
6002         k% = DlgWnd%(240, 60, " Delete Files ", "   Are you sure you want to delete" & CHR$(10) & "     " & x% & " files and directories ?")
6004     ELSE
6006         IF IsDir%() = 1
6008             a$ = "directory " & name$
6010         ELSE
6012             a$ = "file " & name$
6014         END IF
6016         k% = (39 - LEN(a$)) DIV 2
6018         IF k% < 0 THEN k% = 0
6020         REMark ''LONGLINE
6022         a$ = "   Are you sure you want to delete" & CHR$(10) & FILL$(" ", k%) & a$
6024         k% = DlgWnd%(240, 60, " Delete File ", a$)
6026     END IF
6028 :
6030     IF k% = 0 THEN RETurn
6032     IF panelWinWid% * 2 > 602
6034         wid% = 600
6036     ELSE
6038         wid% = 400
6040     END IF
6042     hgt% = panelWinHeight% * 8 DIV  10
6044     left% = (maxWinWid% - wid%) DIV 2
6046     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
6048     ch% = FOPEN(windef$)
6050     PAPER# ch%, 0
6052     INK# ch%, White%
6054     OUTLN# ch%, wid%, hgt%, left%, 50
6056     BORDER# ch%, 1, 2
6058     CLS# ch%
6060     left% = left% + 1
6062     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
6064     ch1% = FOPEN(windef$)
6066     BORDER# ch1%, 1, 2
6068     PAPER# ch1%, 0, 2, 1
6070     CLS# ch1%
6072     PAPER# ch1%, 0
6074     INK# ch1%, White%
6076     CURSOR# ch1%, (wid% - 84) DIV 2, 0
6078     PRINT# ch1%, " Delete Files "
6080     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
6082     PAPER# 0, 0
6084     INK# 0, White%
6086     CLS# 0
6088 :
6090     IF x% = 0
6092         IF IsDir%() = 0
6094             PRINT# 0, "Deleting file " & source$ & name$
6096             DELETE source$ & name$
6098         ELSE
6100             IF DeleteDirectory(source$, name$) = 0
6102                 INK# 0, 2
6104                 REMark ''LONGLINE
6106                 PRINT# 0, "Could not delete all of " & source$ & name$ & "_"
6108                 INK# 0, White%
6110             END IF
6112         END IF
6114     ELSE
6116         REMark ''LONGLINE
6118         PRINT# 0, "Delete Selected list: " & x% & " files and/or directories"
6120         IF crtPanel% = 7
6122             FOR k% = 1 TO LSizedir% + LSizeFile%
6124                 IF GetFFlg%(LeftFiles$,k%) > 1
6126                     IF GetFFlg%(LeftFiles$,k%) = 2
6128                         REMark ''LONGLINE
6130                         PRINT# 0, "Deleting file " & GetFNam$(LeftFiles$, k%) & " ..."
6132                         REMark ''LONGLINE
6134                         DELETE source$ & GetFNam$(LeftFiles$, k%)
6136                     ELSE
6138                         REMark ''LONGLINE
6140                         IF DeleteDirectory(source$, GetFNam$(LeftFiles$, k%)) = 0
6142                             INK# 0, 2
6144                             REMark ''LONGLINE
6146                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(LeftFiles$, k%) & "_"
6148                             INK# 0, White%
6150                         END IF
6152                     END IF
6154                 END IF
6156                 NEXT k%
6158             END FOR k%
6160         ELSE
6162             FOR k% = 1 TO RSizedir% + RSizeFile%
6164                 IF GetFFlg%(RightFiles$, k%) > 1
6166                     IF GetFFlg%(RightFiles$, k%) = 2
6168                         REMark ''LONGLINE
6170                         PRINT# 0, "Deleting file " & GetFNam$(RightFiles$, k%) & " ..."
6172                         REMark ''LONGLINE
6174                         DELETE source$ & GetFNam$(RightFiles$, k%)
6176                     ELSE
6178                         REMark ''LONGLINE
6180                         IF DeleteDirectory(source$, GetFNam$(RightFiles$, k%))
6182                             INK# 0, 2
6184                             REMark ''LONGLINE
6186                             PRINT# 0, "Could not delete all of " & source$ & GetFNam$(RightFiles$, k%) & "_"
6188                             INK# 0, White%
6190                         END IF
6192                     END IF
6194                 END IF
6196                 NEXT k%
6198             END FOR k%
6200         END IF
6202     END IF
6204 :
6206     INK# 0, Green%
6208     REMark ''LONGLINE
6210     PRINT# 0, "Delete process ended - press any key to close window"
6212     INK# 0, White%
6214 :
6216     x% = KEYROW(0)
6218     a$ = INKEY$(-1)
6220 :
6222     WINDOW# 0, 448, 12, 32, 231:
6224     CLOSE# ch1%
6226     OUTLN# ch%, wid%, hgt%, left% - 1, 50
6228     CLOSE# ch%
6230 :
6232     IF crtPanel% = 7
6234         ReloadPanel 7, Index%
6236     ELSE
6238         ReloadPanel 8, Index%
6240     END IF
6242 END DEFine
6244 :
6246 :
6248 REMark ''-----------------------------------------------------------
6250 DEFine PROCedure EXecFile
6252     LOCal filename$, path$, chf%, x%
6254 :
6256     IF crtPanel% = 7
6258         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn
6260         filename$ = GetFNam$(LeftFiles$, LIndex%)
6262         path$ = leftDir$
6264     ELSE
6266         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn
6268         filename$ = GetFNam$(RightFiles$, RIndex%)
6270         path$ = rightDir$
6272     END IF
6274     chf% = FOPEN(path$ & filename$)
6276     IF chf% < 0
6278         SELect ON chf%
6280           = -7:
6282             REMark ''LONGLINE
6284             MessageWnd 200, 60, 2, CHR$(10) & "         File Not Found !"
6286 :
6288           = -9:
6290             REMark ''LONGLINE
6292             MessageWnd 200, 60, 2, CHR$(10) & "           File in use"
6294 :
6296           = REMAINDER :
6298             REMark ''LONGLINE
6300             MessageWnd 200, 60, 2, CHR$(10) & "             Error " & chf%
6302         END SELect
6304      ELSE
6306         CLOSE# chf%
6308         REMark ''use _+ as #, __+ as \ ???
6310         x% = FTYP(\path$ & filename$)
6312         IF x% <> 1
6314             REMark ''LONGLINE
6316             MessageWnd 200, 60, 2, CHR$(10) & "   This is not a EXECable file"
6318         ELSE
6320             EX path$ & filename$
6322         END IF
6324     END IF
6326 END DEFine
6328 :
6330 :
6332 REMark ''----------------------------------------------------------
6334 DEFine FuNction getKey$(c%)
6336     LOCal k$(2)
6338 :
6340     CURSEN #c%
6342     k$ = INKEY$(c%, -1)
6344     CURDIS #c%
6346     RETurn k$
6348 END DEFine getKey$
6350 :
6352 :
6354 REMark ''----------------------------------------------------------
6356 DEFine PROCedure OnEnter
6358     LOCal ext$(10), path$, a$, x%, i%
6360 :
6362     IF crtPanel% = 7
6364         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6366         a$ = GetFNam$(LeftFiles$, LIndex%)
6368         path$ = leftDir$
6370     ELSE
6372         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6374         a$ = GetFNam$(RightFiles$, RIndex%)
6376         path$ = rightDir$
6378     END IF
6380     IF a$ == ".." OR IsDir%() = 1
6382         IF crtPanel% = 7
6384             OpenSubDir LeftFiles$, LIndex%, 7
6386         ELSE
6388             OpenSubDir RightFiles$, RIndex%, 8
6390         END IF
6392         RETurn
6394     END IF
6396 :
6398     REMark ''use _+ as #, __+ as \ ???
6400     IF FTYP(\path$ & a$) = 1
6402         EXecFile
6404         RETurn
6406     END IF
6408 :
6410     REMark ''now get file extension
6412     x% = LEN(a$)
6414     FOR i% = 0 TO x% - 1
6416         IF a$(x% - i%) == "_" THEN EXIT i%
6418         NEXT i%
6420     END FOR i%
6422     IF i% > 0
6424         ext$ = a$(x% - i% TO x%)
6426     ELSE
6428         ext$ = ""
6430     END IF
6432     ext$ = LOWER$(ext$) : x% = 0
6434 :
6436     IF ext$ = "_bas" THEN x% = 1
6438     REMark ''LONGLINE
6440     IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x% = 2
6442     IF ext$ = "_zip" THEN x% = 3
6444     IF ext$ = "_doc" THEN x% = 4
6446     IF ext$ = "_aba" THEN x% = 5
6448     IF ext$ = "_grf" THEN x% = 6
6450     IF ext$ = "_dbf" THEN x% = 7
6452     IF ext$ = "_ssb" THEN x% = 9
6454     IF a$ = "boot" THEN x% = 1
6456 :
6458     SELect ON x%
6460       = 1:
6462         dbg(path$ & a$)
6464         LoadBasFile(path$ & a$)
6466 :
6468       = 2:
6470         DoLrespr path$ & a$
6472 :
6474       = 3:
6476         IF IsZipFile%(path$ & a$) = 1 THEN UnzipFile path$ & a$
6478 :
6480       = 4:
6482         IF IsQuillDoc%(path$ & a$) = 1
6484             IF Xchangeprog$ <> ""
6486                 ExecXchange path$, path$ & a$
6488             END IF
6490         END IF
6492 :
6494       = 5:
6496         IF IsAbacusDoc%(path$ & a$) = 1
6498             IF Xchangeprog$ <> ""
6500                 ExecXchange path$, path$ & a$
6502             END IF
6504         END IF
6506 :
6508       = 6:
6510         IF Xchangeprog$ <> ""
6512             ExecXchange path$, path$ & a$
6514         END IF
6516 :
6518       = 7:
6520         IF IsArchiveDoc%(path$ & a$) = 1
6522             IF Xchangeprog$ <> ""
6524                 ExecXchange path$, path$ & a$
6526             END IF
6528         END IF
6530 :
6532       = 8:
6534         REMark ''LONGLINE
6536         x% = DlgWnd%(240, 60, " Archive Prg ", "     " & a$ & CHR$(10) & "      Open with Xchange Archive ?")
6538         IF x% = 0 THEN RETurn
6540         ExecXchange path$, path$ & a$
6542 :
6544       = 9:
6546         dbg(path$ & a$)
6548         LoadSsbFile(path$ & a$)
6550 :
6552     END SELect
6554 END DEFine
6556 :
6558 :
6560 REMark ''----------------------------------------------------------
6562 DEFine PROCedure UnzipFile (filename$)
6564     LOCal path$, ch%, ch1%, ch2%
6566 :
6568     IF crtPanel% = 7
6570         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6572         path$ = rightDir$
6574     ELSE
6576         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6578         path$ = leftDir$
6580     END IF
6582 :
6584     REMark ''LONGLINE
6586     ch% = DlgWnd%(240, 60, " Unzip File ", "    Are you sure you want to unzip" & CHR$(10) & "     " & filename$ & " ?")
6588     IF ch% = 0 THEN RETurn
6590     ch% = FOPEN("scr_452x230a30x14")
6592     PAPER# ch%, 0
6594     INK# ch%, 7
6596     OUTLN# ch%, 452, 230, 30, 14
6598     BORDER# ch%, 1, 2
6600     CLS# ch%
6602     ch1% = FOPEN("scr_452x12a31x14")
6604     BORDER# ch1%, 1, 2
6606     PAPER# ch1%, 0, 2, 1
6608     CLS# ch1%
6610     PAPER# ch1%, 0
6612     INK# ch1%, 7
6614     AT# ch1%, 0, 37 - (LEN(a$) + 5) DIV 2
6616     PRINT# ch1%, "Unzip" & a$
6618     ch2% = FOPEN("scr_448x204a32x26")
6620     PAPER# ch2%, 0
6622     INK# ch2%, 4
6624     REMark ''LONGLINE
6626     EW ConfigDrv$ & "unzip", #ch2%; "-D" & path$ & " -o " & filename$
6628     PRINT# ch2%, "Press any key ..."
6630     path$ = INKEY$(-1)
6632     CLS# ch1%
6634     CLS# ch2%
6636     CLOSE# ch2%
6638     CLOSE# ch1%
6640     WINDOW# 0, 488, 23, 12, 233
6642     PAPER# 0, 0
6644     INK# 0, White%
6646     OUTLN# ch%, 452, 230, 30, 14
6648     CLOSE# ch%
6650 :
6652     IF crtPanel% = 7
6654         ReloadPanel 8, RIndex%
6656     ELSE
6658         ReloadPanel 7, LIndex%
6660     END IF
6662 END DEFine
6664 :
6666 :
6668 REMark ''----------------------------------------------------------
6670 DEFine PROCedure ExecXchange(path$, filename$)
6672     LOCal savedDATAD$(36), savedPROGD$(36)
6674 :
6676     savedDATAD$ = DATAD$
6678     savedPROGD$ = PROGD$
6680     DATA_USE path$
6682     PROG_USE Xchangepath$
6684     EX Xchangepath$ & Xchangeprog$; filename$
6686     DATA_USE savedDATAD$
6688     PROG_USE savedPROGD$
6690 END DEFine
6692 :
6694 :
6696 REMark ''-----------------------------------------------------------
6698 DEFine PROCedure EditFile(path$, filename$)
6700     LOCal savedDATAD$(36), savedPROGD$(36)
6702 :
6704     savedDATAD$ = DATAD$
6706     savedPROGD$ = PROGD$
6708     DATA_USE path$
6710     PROG_USE EditPath$
6712     EX EditPath$ & Editprog$; path$ & filename$
6714     DATA_USE savedDATAD$
6716     PROG_USE savedPROGD$
6718 END DEFine
6720 :
6722 :
6724 REMark ''-----------------------------------------------------------
6726 DEFine PROCedure AttachBasFileShell(filename$)
6728     TYPE_IN "merge " & "dos1_qlc_cmd_bas" & CHR$(10)
6730     REMark ''LONGLINE
6732     TYPE_IN "32604   QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
6734 END DEFine
6736 :
6738 :
6740 REMark ''-----------------------------------------------------------
6742 DEFine PROCedure LoadBasFile(filename$)
6744     LOCal x%
6746 :
6748     REMark ''QLC_GlobalFilename$ = filename$
6750     SBASIC
6752     COMMAND_LINE
6754     PAUSE 5
6756     TYPE_IN "load " & filename$ & CHR$(10)
6758     REMark ''type_in "dline 32600 to" & chr$(10)
6760 :
6762     AttachBasFileShell filename$
6764 :
6766     TYPE_IN "QLC_INIT" & CHR$(10)
6768     REMark ''type_in "SAVE_O " & filename$ & chr$(10)
6770     TYPE_IN "wtv" & CHR$(10)
6772     AT 2,0
6774     TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
6776     TYPE_IN "ED" & CHR$(10)
6778 END DEFine
6780 :
6782 :
6784 REMark ''-----------------------------------------------------------
6786 REMark ''QLXC IDE simplified SSB to BAS conversion
6788 REMark ''- missing support for @Lables and #include, now !!!
6790 DEFine FuNction CompileSsb2Bas(ssb_filename$, bas_filename$)
6792   LOCal i, x$, ierr, oerr
6794 :
6796   REMark ''use _+ as #, __+ as \ ???
6798   ierr = FOP_IN(#10, ssb_filename$)
6800   oerr = FOP_OVER(#11, bas_filename$)
6802   PRINT# 11, "1 rem &&SSBGEN"
6804   linenum = 10
6806   REPeat linenum
6808     INPUT# 10, in$
6810     REMark ''use _+ as #, __+ as \ ???
6812     IF EOF(#10) THEN EXIT
6814     IF (CHR$(38) & CHR$(38) & "QLCGEN") INSTR in$ THEN EXIT
6816     out$ = in$
6818     IF in$ = "" THEN out$ = ":"
6820     pos = (CHR$(39) & CHR$(39) INSTR in$)
6822     REMark ''or ("##" instr in$) or ("//" instr in$) + odd '
6824     IF pos > 0
6826       IF pos > 1
6828         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT linenum : NEXT i
6830         IF i < pos
6832             comment$ = ": rem"
6834         ELSE
6836             comment$ = "rem "
6838         END IF
6840         out$ = in$(1 TO pos - 1) & comment$
6842       ELSE out$ = "rem "
6844       END IF
6846       out$ = out$ & in$(pos TO)
6848     END IF
6850     PRINT# 11, linenum & " " & out$
6852     linenum = linenum + 2
6854   END REPeat
6856   CLOSE# 10
6858   CLOSE# 11
6860   RETurn 0
6862 END DEFine
6864 :
6866 :
6868 REMark ''-----------------------------------------------------------
6870 DEFine PROCedure LoadSsbFile(filename$)
6872     LOCal ssb_filename$, bas_filename$, i, x$
6874 :
6876     ssb_filename$ = filename$
6878     REMark ''LONGLINE
6880     bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
6882 :
6884     _err = CompileSsb2Bas(ssb_filename$, bas_filename$)
6886     LoadBasFile bas_filename$
6888 END DEFine
6890 :
6892 :
6894 REMark ''----------------------------------------------------------
6896 DEFine PROCedure DoEdit
6898     LOCal path$, a$
6900 :
6902     IF crtPanel% = 7
6904         IF LIndex% > LSizedir% + LSizeFile% THEN RETurn
6906         a$ = GetFNam$(LeftFiles$, LIndex%)
6908         path$ = leftDir$
6910     ELSE
6912         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
6914         a$ = GetFNam$(RightFiles$, RIndex%)
6916         path$ = rightDir$
6918     END IF
6920 :
6922     REMark ''FIXME mixworx nonsese, this function HAS NO ARGS !!!
6924     IF IsDir%(path$ & a$) = 1 THEN RETurn
6926     IF IsQuillDoc%(path$ & a$) = 1
6928         IF Xchangeprog$ <> ""
6930             ExecXchange path$, path$ & a$
6932             RETurn
6934         END IF
6936     ELSE
6938         EditFile path$, a$
6940     END IF
6942 END DEFine
6944 :
6946 :
6948 REMark ''-----------------------------------------------------------
6950 DEFine PROCedure DoLrespr(filename$)
6952     LOCal x%
6954 :
6956     REMark ''LONGLINE
6958     x% = DlgWnd%(240, 60, " lrespr File ", "    Are you sure you want to lrespr" & CHR$(10) & "     " & filename$ & " ?")
6960     IF x% = 0 THEN RETurn
6962     COMMAND_LINE
6964     PAUSE 5
6966     TYPE_IN "lrespr " & filename$ & CHR$(10)
6968 END DEFine
6970 :
6972 :
6974 REMark ''----------------------------------------------------------
6976 DEFine FuNction IsAbacusDoc%(a$)
6978     LOCal ch%, q$, i%, k%
6980 :
6982     ch% = FOPEN(a$)
6984     IF ch% <= 0 THEN RETurn 0
6986     q$ = ""
6988     FOR i% = 1 TO 4
6990         BGET# ch%, k%
6992         q$ = q$ & CHR$(k%)
6994         NEXT i%
6996     END FOR i%
6998     CLOSE# ch%
7000     IF q$ = "ABM1" THEN RETurn 1 : ELSE RETurn 0
7002 END DEFine
7004 :
7006 :
7008 REMark ''-----------------------------------------------------------
7010 DEFine FuNction IsArchiveDoc%(a$)
7012     LOCal ch%, q$, i%, k%
7014 :
7016     ch% = FOPEN(a$)
7018     IF ch% <= 0 THEN RETurn 0
7020     q$ = ""
7022     BGET# ch%\1, k%
7024     FOR i% = 1 TO 8
7026         BGET# ch%, k%
7028         q$ = q$ & CHR$(k%)
7030         NEXT i%
7032     END FOR i%
7034     CLOSE# ch%
7036     IF q$ = "vrm1dbf0" THEN RETurn 1 : ELSE RETurn 0
7038 END DEFine
7040 :
7042 :
7044 REMark ''-----------------------------------------------------------
7046 DEFine PROCedure ReloadPanel(panel%, Index%)
7048     LOCal page%, x%
7050 :
7052     IF panel% = 7
7054         DIM LeftFiles$(MaxFiles%, _fMax%)
7056         LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
7058         IF LEN(leftDir$) = 5
7060             LMinPos% = 1
7062         ELSE
7064             LMinPos% = 0
7066         END IF
7068         IF Index% < LMinPos%
7070             Index% = LMinPos%
7072         END IF
7074         IF Index% > LSizedir% + LSizeFile%
7076             Index% = LMinPos%
7078         END IF
7080         LIndex% = Index%
7082         x% = Index% + (LMinPos% = 0)
7084         page% = x% DIV rowno%
7086         IF x% MOD rowno% > 0 THEN page% = page% + 1
7088         LStartPos% = (page% - 1) * rowno% + LMinPos%
7090         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7092     ELSE
7094         DIM RightFiles$(MaxFiles%, _fMax%)
7096         LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
7098         IF LEN(rightDir$) = 5
7100             RMinPos% = 1
7102         ELSE
7104             RMinPos% = 0
7106         END IF
7108         IF Index% < RMinPos% THEN Index% = RMinPos%
7110         IF Index% > RSizedir% + RSizeFile%
7112             Index% = RMinPos%
7114         END IF
7116         RIndex% = Index%
7118         x% = Index% + (RMinPos% = 0)
7120         page% = x% DIV rowno%
7122         IF x% MOD rowno% > 0 THEN page% = page% + 1
7124         RStartPos% = (page% - 1) * rowno% + RMinPos%
7126         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7128     END IF
7130 END DEFine
7132 :
7134 :
7136 REMark ''-----------------------------------------------------------
7138 DEFine PROCedure SelectAll
7140     LOCal i%
7142 :
7144     IF crtPanel% = 7
7146         FOR i% = 1 TO LSizedir% + LSizeFile%
7148             REMark ''LONGLINE
7150             IF GetFFlg%(LeftFiles$, i%) < 2 THEN PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
7152         END FOR i%
7154         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7156     ELSE
7158         FOR i% = 1 TO RSizedir% + RSizeFile%
7160             REMark ''LONGLINE
7162             IF GetFFlg%(RightFiles$, i%) < 2 THEN PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
7164         END FOR i%
7166         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7168     END IF
7170 END DEFine
7172 :
7174 :
7176 REMark ''-----------------------------------------------------------
7178 DEFine PROCedure UnSelectAll
7180     LOCal i%
7182 :
7184     IF crtPanel% = 7
7186         FOR i% = 1 TO LSizedir% + LSizeFile%
7188             REMark ''LONGLINE
7190             IF GetFFlg%(LeftFiles$, i%) > 1 THEN PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
7192         END FOR i%
7194         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7196     ELSE
7198         FOR i% = 1 TO RSizedir% + RSizeFile%
7200             REMark ''LONGLINE
7202             IF GetFFlg%(RightFiles$, i%) > 1 THEN PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
7204         END FOR i%
7206         ListFiles RightFiles$, RStartPos%, RIndex%, 8
7208     END IF
7210 END DEFine
7212 :
7214 :
7216 REMark ''-----------------------------------------------------------
7218 REMark ''On QPC2 the char width gets reset so we have to set it again
7220 DEFine PROCedure Set78CharSet
7222 :
7224     IF mainFountBase > 0
7226         IF ClassicFont% = 0
7228             CHAR_USE# leftPanelWin%, mainFountBase, 0
7230             CHAR_INC# leftPanelWin%, 5, 10
7232             CHAR_USE# rightPanelWin%, mainFountBase, 0
7234             CHAR_INC# rightPanelWin%, 5, 10
7236         END IF
7238     END IF
7240 END DEFine
7242 :
7244 :
7246 REMark ''----------------------------------------------------------
7248 DEFine FuNction TestFount%(fountBase)
7250     LOCal fountMask%, fountMax%, char%, row%
7252 :
7254     fountMask% = 3 : REMark ''*** ------XX
7256     fountMax% = PEEK(fountBase + 1)
7258     FOR char% = 0 TO fountMax%
7260     FOR row% = 0 TO 8
7262         REMark ''*** appears to be a FAT fount
7264         REMark ''LONGLINE
7266         IF PEEK(fountBase + 2 + char% * 9 + row%) && fountMask% THEN RETurn 2
7268     END FOR row%
7270     END FOR char%
7272 :
7274     RETurn 1 : REMark ''*** Does not appear to be a FAT fount
7276 :
7278 END DEFine
7280 :
7282 :
7284 REMark ''----------------------------------------------------------
7286 REFERENCE fList$(0, 0)
7288 DEFine FuNction GetFNam$(fList$, fIndex%)
7290     REMark ''LONGLINE
7292     RETurn fList$(fIndex%, 3 TO 2 + STRING%(fList$(fIndex%, 1 TO 2)))
7294 END DEFine
7296 :
7298 :
7300 REMark ''----------------------------------------------------------
7302 REFERENCE fList$(0, 0)
7304 DEFine FuNction GetFLen(fList$, fIndex%)
7306     RETurn LONGINTEGER(fList$(fIndex%, _fLen% TO _fTyp% - 1))
7308 END DEFine
7310 :
7312 :
7314 REMark ''-----------------------------------------------------------
7316 REFERENCE fList$(0, 0)
7318 DEFine FuNction GetFTyp%(fList$)
7320     RETurn STRING%(fList$(fIndex%, _fTyp% TO _fDat% - 1))
7322 END DEFine
7324 :
7326 :
7328 REMark ''-----------------------------------------------------------
7330 REFERENCE fList$(0, 0)
7332 DEFine FuNction GetFDat(fList$, fIndex%)
7334     RETurn LONGINTEGER(fList$(fIndex%, _fDat% TO _fPar% - 1))
7336 END DEFine
7338 :
7340 :
7342 REMark ''-----------------------------------------------------------
7344 REFERENCE fList$(0, 0)
7346 DEFine FuNction GetFPar%(fList$, fIndex%)
7348     RETurn STRING%(fList$(fIndex%, _fPar% TO _fFlg% - 1))
7350 END DEFine
7352 :
7354 :
7356 REMark ''-----------------------------------------------------------
7358 REFERENCE fList$(0, 0)
7360 DEFine FuNction GetFFlg%(fList$, fIndex%)
7362     RETurn STRING%(fList$(fIndex%, _fFlg% TO _fMax%))
7364 END DEFine
7366 :
7368 :
7370 REMark ''-----------------------------------------------------------
7372 REFERENCE fList$(0, 0)
7374 DEFine PROCedure PutFNam(fList$, fIndex%, newVal$)
7376     LOCal nVLen%
7378 :
7380     nVLen% = LEN(newVal$)
7382     IF nVLen% > maxFNLen% THEN nVLen% = maxFNLen%
7384     REMark ''LONGLINE
7386     fList$(fIndex%, 1 TO 2 + nVLen%) = STRING$(newVal$(1 TO nVLen%))
7388 END DEFine
7390 :
7392 :
7394 REMark ''-----------------------------------------------------------
7396 REFERENCE fList$(0, 0)
7398 DEFine PROCedure PutFLen(fList$, fIndex%, newVal)
7400     fList$(fIndex%, _fLen% TO _fTyp% - 1) = LONGINTEGER$(newVal)
7402 END DEFine
7404 :
7406 :
7408 REMark ''-----------------------------------------------------------
7410 REFERENCE fList$(0, 0)
7412 DEFine PROCedure PutFTyp(fList$, fIndex%, newVal%)
7414     fList$(fIndex%, _fTyp% TO _fDat% - 1) = INTEGER$(newVal%)
7416 END DEFine
7418 :
7420 :
7422 REMark ''-----------------------------------------------------------
7424 REFERENCE fList$(0, 0)
7426 DEFine PROCedure PutFDat(fList$, fIndex%, newVal)
7428     fList$(fIndex%, _fDat% TO _fPar% - 1) = LONGINTEGER$(newVal)
7430 END DEFine
7432 :
7434 :
7436 REMark ''-----------------------------------------------------------
7438 REFERENCE fList$(0, 0)
7440 DEFine PROCedure PutFPar(fList$, fIndex%, newVal%)
7442     fList$(fIndex%, _fPar% TO _fFlg% - 1) = INTEGER$(newVal%)
7444 END DEFine
7446 :
7448 :
7450 REMark ''-----------------------------------------------------------
7452 REFERENCE fList$(0, 0)
7454 DEFine PROCedure PutFFlg(fList$, fIndex%, newVal%)
7456     fList$(fIndex%, _fFlg% TO _fMax%) = INTEGER$(newVal%)
7458 END DEFine
7460 :
7462 :
7464 REMark ''-----------------------------------------------------------
7466 REFERENCE fList$(0, 0), fListDest$(0, 0)
7468 DEFine PROCedure CopyRec(fList$, fIndex%, fListDest$, fDestIndex%)
7470     fListDest$(fDestIndex%, 1 TO _fMax%) = fList$(fIndex%, 1 TO _fMax%)
7472 END DEFine
7474 :
7476 :
7478 REMark ''-----------------------------------------------------------
7480 DEFine FuNction isBasicRunning
7482     IF BASIC_B%(111) <> 0
7484         RETurn 0
7486     ELSE
7488         REMark ''FIXME mixworx weird if sequences
7490         REMark ''break - Ctrl-Space pressed
7492         IF BASIC_B%(143) = 0 : RETurn 0
7494         REMark ''stop occurred
7496         IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0
7498         REMark ''Program is running
7500         RETurn 1
7502     END IF
7504 END DEFine
7506 :
7508 :
7510 REMark ''-----------------------------------------------------------
7512 DEFine FuNction isBasicProgramLoaded
7514     RETurn BASIC_W%(BASIC_L(16))
7516 END DEFine
7518 :
7520 :
7522 REMark ''-----------------------------------------------------------
7524 REFERENCE fList$(0, 0), r_StartPos%, r_Index%
7526 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
7528     LOCal top%, x%, size%
7530 :
7532     IF ch% = 7
7534         r_StartPos% = LMinPos%
7536     ELSE
7538         r_StartPos% = RMinPos%
7540     END IF
7542     r_Index% = r_StartPos%
7544     ListFiles fList$, r_StartPos%, r_Index%, ch%
7546 END DEFine
7548 :
7550 :
7552 REMark ''----------------------------------------------------------
7554 REFERENCE fList$(0, 0), r_StartPos%, r_Index%
7556 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
7558     LOCal top%
7560 :
7562     IF ch% = 7
7564         top% = LMinPos%
7566         r_Index% = LSizeFile% + LSizedir%
7568     ELSE
7570         top% = RMinPos%
7572         r_Index% = RSizeFile% + RSizedir%
7574     END IF
7576     r_StartPos% = r_Index% - 19
7578     IF r_StartPos% < top% THEN r_StartPos% = top%
7580     ListFiles fList$, r_StartPos%, r_Index%, ch%
7582 END DEFine
7584 :
7586 :
7588 REMark ''-----------------------------------------------------------
7590 DEFine PROCedure LRUNBasic
7592     LOCal i%, a$, path$, ext$
7594 :
7596     IF crtPanel% = 7
7598         IF LIndex%>LSizedir% + LSizeFile% THEN RETurn
7600         a$ = GetFNam$(LeftFiles$, LIndex%)
7602         path$ = leftDir$
7604     ELSE
7606         IF RIndex% > RSizedir% + RSizeFile% THEN RETurn
7608         a$ = GetFNam$(RightFiles$, RIndex%)
7610         path$ = rightDir$
7612     END IF
7614     IF a$ == ".." OR IsDir%() = 1 THEN RETurn
7616     REMark ''now get file extension
7618     x% = LEN(a$)
7620     FOR i% = 0 TO x% - 1
7622         IF a$(x% - i%) == "_" THEN EXIT i%
7624         NEXT i%
7626     END FOR i%
7628     IF i% > 0
7630         ext$ = a$(x% - i% TO x%)
7632     ELSE
7634         ext$ = ""
7636     END IF
7638     ext$ = LOWER$(ext$)
7640     IF ext$ <> "_bas" AND a$ <> "boot" THEN RETurn
7642     IF isBasicRunning = 1
7644         REMark ''LONGLINE
7646         MessageWnd 200, 60, 2, CHR$(10) & "        BASIC is running" & CHR$(10) & "       Cannot run _bas now!"
7648         RETurn
7650     END IF
7652     IF (isBasicProgramLoaded > 0) AND (isBasicProgramEdited = 1)
7654         REMark ''LONGLINE
7656         i% = DlgWnd%(240, 60, " Basic program loaded ", "       A Basic program is loaded" & CHR$(10) & "         Loose any changes made?")
7658         IF i% = 0 THEN RETurn
7660     END IF
7662     COMMAND_LINE
7664     PAUSE 5
7666     TYPE_IN CHR$(27) & CHR$(27) & CHR$(27)
7668     PAUSE 5
7670     TYPE_IN "LRUN " & path$ & a$ & CHR$(10)
7672 END DEFine
7674 :
7676 :
7678 REMark ''-----------------------------------------------------------
7680 DEFine PROCedure SetPalletteQL
7682     REMark ''LONGLINE
7684     PALETTE_QL 0, 0, 0, 255*256*256, 255*256*256, 255*256, 255*256, 255*256*256+255*256+255, 255*256*256+255*256+255
7686 END DEFine
7688 :
7690 :
7692 REMark ''-----------------------------------------------------------
7694 DEFine FuNction isBasicProgramEdited
7696     IF BASIC_B%(142) = 255
7698         RETurn 1
7700     ELSE
7702         RETurn 0
7704     END IF
7706 END DEFine
7708 :
7710 :
7712 REMark ''-----------------------------------------------------------
7714 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
7716     LOCal x%, ch%, loop, d$, fp, newname$, newsource$
7718     LOCal newdest$, totrim
7720 :
7722     IF DirExists%(dest$ & name$) = 0
7724         REMark ''LONGLINE
7726         x% = Create1Dir%(name$, dest$ & name$, panel%, 0, CheckNoQ%, UpdateList%)
7728         IF x% = 0 THEN RETurn 0
7730     END IF
7732     PRINT# 0, "Copy " & source$ & name$ & " to " & dest$ & name$
7734     WCOPY source$ & name$ TO dest$ & name$
7736 :
7738     ch% = FOP_DIR(source$ & name$) : REMark ''open channel to directory
7740 :
7742     IF ch% < 0 THEN RETurn : REMark ''unable to open directory
7744 :
7746     fp = 14 : REMark ''file position in directory for filename
7748 :
7750     newsource$ = source$ & name$
7752     IF newsource$(LEN(newsource$)) <> "_"
7754         newsource$ = newsource$ & "_"
7756     END IF
7758     newdest$ = dest$ & name$
7760     IF newdest$(LEN(newdest$)) <> "_"
7762         newdest$ = newdest$ & "_"
7764     END IF
7766 :
7768     REPeat loop
7770         BGET# ch%\fp
7772         REMark ''FIXME mixworx weird if sequence
7774         REMark ''use _+ as #, __+ as \ ???
7776         IF EOF(#ch%) THEN CLOSE# ch% : EXIT loop
7778         GET# ch%, d$ : REMark ''get a directory entry name
7780         IF LEN(d$) > 0
7782             REMark ''a directory length of 0 may be a deleted file
7784             BGET# ch%\fp - 9 : REMark ''file type byte
7786             REMark ''use _+ as #, __+ as \ ???
7788             IF CODE(INKEY$(#ch%)) = 255
7790                 REMark ''this is a subdirectory
7792                 REMark ''so we need to copy this
7794 :
7796                 REMark ''Extract file name and check length
7798                 totrim = LEN(newsource$) - 4
7800                 newname$ = d$(totrim TO)
7802                 IF LEN(newdest$ & newname$) > 36
7804                     INK# 0, 2
7806                     REMark ''LONGLINE
7808                     PRINT# 0, "Directory " & newdest$ & newname$ & " not created  Name too long"
7810                     INK# 0, White%
7812                 ELSE
7814                     REMark ''LONGLINE
7816                     x% = CopyFullDir%(newname$, newsource$, newdest$, panel%, 0, 0, 0)
7818                 END IF
7820             END IF
7822         END IF
7824         fp = fp + 64
7826     END REPeat loop
7828     RETurn 1
7830 END DEFine
7832 :
7834 :
7836 REMark ''-----------------------------------------------------------
7838 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
7840     LOCal ch%, ch1%, i%, x%, a$, Index%,page%
7842     LOCal id%, left%,windef$, hgt%, wid%
7844 :
7846 :
7848     IF panelWinWid% * 2 > 602
7850         wid% = 600
7852     ELSE
7854         wid% = 400
7856     END IF
7858     hgt% = panelWinHeight% * 8 DIV 10
7860     left% = (maxWinWid% - wid%) DIV 2
7862     windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x50"
7864     ch% = FOPEN(windef$)
7866     PAPER# ch%, 0
7868     INK# ch%, White%
7870     OUTLN# ch%, wid%, hgt%, left%, 50
7872     BORDER# ch%, 1, 2
7874     CLS# ch%
7876     left% = left% + 1
7878     windef$ = "scr_" & (wid% - 2) & "x12a" & left% & "x51"
7880     ch1% = FOPEN(windef$)
7882     BORDER# ch1%, 1 , 2
7884     PAPER# ch1%, 0, 2, 1
7886     CLS# ch1%
7888     PAPER# ch1%, 0
7890     INK# ch1%, White%
7892     CURSOR# ch1%, (wid% - 90) DIV 2, 0
7894     PRINT# ch1%, " Copy Directory "
7896     WINDOW# 0, wid% - 4, hgt% - 16, left% + 1, 63
7898     PAPER# 0, 0
7900     INK# 0, White%
7902     CLS# 0
7904     REMark ''LONGLINE
7906     PRINT# 0, "Copy Directory " & source$ & name$ & " to " & dest$
7908     res% = CopyFullDir%(name$, source$, dest$, panel%, 0, 1, 0)
7910     INK# 0, Green%
7912     REMark ''LONGLINE
7914     PRINT# 0, "Copy process ended - press any key to close window"
7916     INK# 0, White%
7918     x% = KEYROW(0)
7920     a$ = INKEY$(-1)
7922     WINDOW# 0, 448, 12, 32, 231:
7924     CLOSE# ch1%
7926     OUTLN# ch%, wid%, hgt%, left% - 1, 50
7928     CLOSE# ch%
7930 :
7932     REMark ''if copy OK then Add the dir name to the list
7934     REMark ''in the destination panel and refresh screen
7936     IF res% = 1
7938         IF panel% = 8
7940             res% = Find%(name$, id%, RightFiles$, 1, RSizedir%)
7942             IF res% = 0
7944                 REMark ''LONGLINE
7946                 res% = Insert%(name$, id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
7948                 RIndex% = id%
7950                 id% = id% + (RMinPos% = 0)
7952                 page% = id% DIV rowno%
7954                 IF id% MOD rowno% > 0
7956                     page% = page% + 1
7958                 END IF
7960                 RStartPos% = (page% - 1) * rowno% + RMinPos%
7962                 ListFiles RightFiles$, RStartPos%, RIndex%, 8
7964             END IF
7966         ELSE
7968             res% = Find%(name$, id%, LeftFiles$, 1, LSizedir%)
7970             IF res% = 0
7972                 REMark ''LONGLINE
7974                 res% = Insert%(name$, id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
7976                 LIndex% = id%
7978                 id% = id% + (LMinPos% = 0)
7980                 page% = id% DIV rowno%
7982                 IF id% MOD rowno% > 0
7984                     page% = page% + 1
7986                 END IF
7988                 LStartPos% = (page% - 1) * rowno% + LMinPos%
7990                 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7992             END IF
7994         END IF
7996     END IF
7998 END DEFine
8000 :
8002 :
8004 REMark ''----------------------------------------------------------
8006 DEFine FuNction DeleteDirectory(source$, name$)
8008     LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
8010 :
8012     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
8014     PRINT# 0, "Deleting directory " & source$ & name$ & "..."
8016     WDEL source$ & name$
8018     ch% = FOP_DIR(source$ & name$) : REMark ''open channel to directory
8020     IF ch% < 0 THEN RETurn : REMark ''unable to open directory
8022     fp = 14 : REMark ''file position in directory for filename
8024     newsource$ = source$ & name$
8026     IF newsource$(LEN(newsource$)) <> "_"
8028         newsource$ = newsource$ & "_"
8030     END IF
8032     REPeat loop
8034         BGET# ch%\fp
8036         REMark ''FIXME mixworx weird if sequence
8038         REMark ''use _+ as #, __+ as \ ???
8040         IF EOF(#ch%) THEN CLOSE# ch% : EXIT loop
8042         GET# ch%, d$ : REMark ''get a directory entry name
8044         IF LEN(d$) > 0
8046             REMark ''a directory length of 0 may be a deleted file
8048             BGET# ch%\fp - 9 : REMark ''file type byte
8050             REMark ''use _+ as #, __+ as \ ???
8052             IF CODE(INKEY$(#ch%)) = 255
8054                 REMark ''this is a subdirectory
8056                 REMark ''so we need to delete this
8058 :
8060                 REMark ''Extract file name and check length
8062                 totrim = LEN(newsource$) - 4
8064                 newname$ = d$(totrimto)
8066                 x% = DeleteDirectory(newsource$, newname$)
8068             END IF
8070         END IF
8072         fp = fp + 64
8074     END REPeat loop
8076 :
8078     REMark ''Now check that directory is empty
8080     IF isDirEmpty(source$ & name$) = 1
8082         DELETE source$ & name$
8084         RETurn 1
8086     ELSE
8088         RETurn 0
8090     END IF
8092 END DEFine
8094 :
8096 :
8098 REMark ''----------------------------------------------------------
8100 DEFine FuNction isDirEmpty(DirName$)
8102     LOCal ch%, fp, d$, loop, res%
8104 :
8106     ch% = FOP_DIR(DirName$) : REMark ''open channel to directory
8108     IF ch% < 0 THEN RETurn 0: REMark ''unable to open directory
8110     res% = 1
8112     fp = 14 : REMark ''file position in directory for filename
8114     REPeat loop
8116         BGET# ch%\fp
8118         REMark ''FIXME mixworx weird if sequences
8120         REMark ''use _+ as #, __+ as \ ???
8122         IF EOF(#ch%) THEN : EXIT loop
8124         GET# ch%, d$ : REMark ''get a directory entry name
8126         IF LEN(d$) > 0 THEN res% = 0: EXIT loop
8128         REMark ''if file name >0 then we found a file
8130         REMark ''and we set result to 1
8132         fp = fp + 64
8134     END REPeat loop
8136     CLOSE# ch%
8138     RETurn res%
8140 END DEFine
8142 :
8144 :
8146 REMark ''----------------------------------------------------------
8148 DEFine PROCedure CompareDirs
8150     LOCal i%, res%
8152 :
8154     REMark ''Unselect all left files
8156     FOR i% = 1 TO LSizedir% + LSizeFile%
8158         IF GetFFlg%(LeftFiles$, i%) > 1
8160             REMark ''LONGLINE
8162             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8164         END IF
8166     END FOR i%
8168 :
8170     REMark ''Select all right files
8172     FOR i% = 1 TO RSizedir% + RSizeFile%
8174         IF GetFFlg%(RightFiles$, i%) < 2
8176             REMark ''LONGLINE
8178             PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
8180         END IF
8182     END FOR i%
8184 :
8186     REMark ''Parse left directory list and compare it to right
8188     FOR i% = 1 TO LSizedir%
8190         REMark ''LONGLINE
8192         res% = Find%(GetFNam$(LeftFiles$, i%), id%, RightFiles$, 1, RSizedir%)
8194         IF res% = 0
8196             REMark ''LONGLINE
8198             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8200         ELSE
8202             REMark ''LONGLINE
8204             PutFFlg RightFiles$, id%, GetFFlg%(RightFiles$, id%) ^^ 2
8206         END IF
8208         NEXT i%
8210     END FOR i%
8212 :
8214     REMark ''Parse left file list and compare it to right
8216     FOR i% = LSizedir% + 1 TO LSizedir% + LSizeFile%
8218         REMark ''LONGLINE
8220         res% = Find%(GetFNam$(LeftFiles$, i%), id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
8222         IF res% = 0
8224             PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
8226         ELSE
8228             REMark ''LONGLINE
8230             IF GetFLen(LeftFiles$, i%) = GetFLen(RightFiles$, id%)
8232                 REMark ''LONGLINE
8234                 PutFFlg RightFiles$, id%, GetFFlg%(RightFiles$, id%) ^^ 2
8236             ELSE
8238                 REMark ''LONGLINE
8240                 PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8242             END IF
8244         END IF
8246         NEXT i%
8248     END FOR i%
8250 :
8252     REMark ''refresh screen
8254     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
8256     ListFiles RightFiles$, RStartPos%, RIndex%, 8
8258 END DEFine
8260 :
8262 :
8264 REMark ''----------------------------------------------------------
8266 DEFine PROCedure InvertSelection
8268     LOCal i%
8270 :
8272     IF crtPanel% = 7
8274         FOR i% = 1 TO LSizedir% + LSizeFile%
8276             REMark ''LONGLINE
8278             PutFFlg LeftFiles$, i%, GetFFlg%(LeftFiles$, i%) ^^ 2
8280         END FOR i%
8282         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
8284     ELSE
8286         FOR i% = 1 TO RSizedir% + RSizeFile%
8288             REMark ''LONGLINE
8290             PutFFlg RightFiles$, i%, GetFFlg%(RightFiles$, i%) ^^ 2
8292         END FOR i%
8294         ListFiles RightFiles$, RStartPos%, RIndex%, 8
8296     END IF
8298 END DEFine
8300 :
8302 :
8304 :
8306 :
32600 REMark &&QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604   QLC_GlobalFilename$ = 'dos1_QLC_qlxc_bas'
32616   XX=RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618   XX=RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620   LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628   RUN
32630 END DEFine
32632 DEFine PROCedure e
32634   WTV
32636   PAPER #2,0 : INK #2,4
32638 END DEFine
32640 DEFine PROCedure x
32642   s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648   s : QUIT
32650 END DEFine
32652 DEFine PROCedure s
32653   TYPE_IN "1 REMark &&SSBGEN &&SAVE" & CHR$(10)
32654   SAVE QLC_GlobalFilename$
32656   PRINT #2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662   LOAD QLC_GlobalFilename$
32664   PRINT #2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670   WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676   REMark DLINE 32600 TO
32678   TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684   PRINT #0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690   IF i = 0 THEN i = 1
32692   TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698   OPEN #99, "scr_"
32700   WINDOW #99, 120,16,0,0 : PAPER #99,0 : INK #99,7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706   PAPER #99,7 : INK #99,2 : PRINT #99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712   STOP
32714 END DEFine
